? 404

[ Shin Bypassed ]




Upload:

Command:

landifun@18.216.224.194: ~ $
#!/usr/bin/bash
KEXEC=/sbin/kexec

KDUMP_KERNELVER=""
KDUMP_KERNEL=""
KDUMP_COMMANDLINE=""
KEXEC_ARGS=""
MKDUMPRD="/sbin/mkdumprd -f"
MKFADUMPRD="/sbin/mkfadumprd"
DRACUT_MODULES_FILE="/usr/lib/dracut/modules.txt"
SAVE_PATH=/var/crash
SSH_KEY_LOCATION="/root/.ssh/kdump_id_rsa"
DUMP_TARGET=""
DEFAULT_INITRD=""
DEFAULT_INITRD_BAK=""
INITRD_CHECKSUM_LOCATION=""
KDUMP_INITRD=""
TARGET_INITRD=""
#kdump shall be the default dump mode
DEFAULT_DUMP_MODE="kdump"
image_time=0

standard_kexec_args="-p"

# Some default values in case /etc/sysconfig/kdump doesn't include
KDUMP_COMMANDLINE_REMOVE="hugepages hugepagesz slub_debug"

if [[ -f /etc/sysconfig/kdump ]]; then
	. /etc/sysconfig/kdump
fi

[[ $dracutbasedir ]] || dracutbasedir=/usr/lib/dracut
. $dracutbasedir/dracut-functions.sh
. /lib/kdump/kdump-lib.sh
. /lib/kdump/kdump-logger.sh

#initiate the kdump logger
if ! dlog_init; then
	echo "failed to initiate the kdump logger."
	exit 1
fi

KDUMP_TMPDIR=$(mktemp --tmpdir -d kdump.XXXX)
trap '
    ret=$?;
    rm -rf "$KDUMP_TMPDIR"
    exit $ret;
    ' EXIT

single_instance_lock()
{
	local rc timeout=5 lockfile

	if [[ -d /run/lock ]]; then
		lockfile=/run/lock/kdump
	else
		# when updating package using virt-customize, /run/lock doesn't exist
		lockfile=/tmp/kdump.lock
	fi

	if ! exec 9> $lockfile; then
		derror "Create file lock failed"
		exit 1
	fi

	flock -n 9
	rc=$?

	while [[ $rc -ne 0 ]]; do
		dinfo "Another app is currently holding the kdump lock; waiting for it to exit..."
		flock -w $timeout 9
		rc=$?
	done
}

determine_dump_mode()
{
	# Check if firmware-assisted dump is enabled
	# if yes, set the dump mode as fadump
	if is_fadump_capable; then
		dinfo "Dump mode is fadump"
		DEFAULT_DUMP_MODE="fadump"
	fi
	ddebug "DEFAULT_DUMP_MODE=$DEFAULT_DUMP_MODE"
}

save_core()
{
	coredir="/var/crash/$(date +"%Y-%m-%d-%H:%M")"

	mkdir -p "$coredir"
	ddebug "cp --sparse=always /proc/vmcore $coredir/vmcore-incomplete"
	if cp --sparse=always /proc/vmcore "$coredir/vmcore-incomplete"; then
		mv "$coredir/vmcore-incomplete" "$coredir/vmcore"
		dinfo "saved a vmcore to $coredir"
	else
		derror "failed to save a vmcore to $coredir"
	fi

	# pass the dmesg to Abrt tool if exists, in order
	# to collect the kernel oops message.
	# https://fedorahosted.org/abrt/
	if [[ -x /usr/bin/dumpoops ]]; then
		ddebug "makedumpfile --dump-dmesg $coredir/vmcore $coredir/dmesg"
		makedumpfile --dump-dmesg "$coredir/vmcore" "$coredir/dmesg" > /dev/null 2>&1
		ddebug "dumpoops -d $coredir/dmesg"
		if dumpoops -d "$coredir/dmesg" > /dev/null 2>&1; then
			dinfo "kernel oops has been collected by abrt tool"
		fi
	fi
}

rebuild_fadump_initrd()
{
	if ! $MKFADUMPRD "$DEFAULT_INITRD_BAK" "$TARGET_INITRD" --kver "$KDUMP_KERNELVER"; then
		derror "mkfadumprd: failed to make fadump initrd"
		return 1
	fi

	return 0
}

check_earlykdump_is_enabled()
{
	grep -q -w "rd.earlykdump" /proc/cmdline
}

rebuild_kdump_initrd()
{
	ddebug "rebuild kdump initrd: $MKDUMPRD $TARGET_INITRD $KDUMP_KERNELVER"
	if ! $MKDUMPRD "$TARGET_INITRD" "$KDUMP_KERNELVER"; then
		derror "mkdumprd: failed to make kdump initrd"
		return 1
	fi

	if check_earlykdump_is_enabled; then
		dwarn "Tips: If early kdump is enabled, also require rebuilding the system initramfs to make the changes take effect for early kdump."
	fi

	return 0
}

rebuild_initrd()
{
	if [[ ! -w $(dirname "$TARGET_INITRD") ]]; then
		derror "$(dirname "$TARGET_INITRD") does not have write permission. Cannot rebuild $TARGET_INITRD"
		return 1
	fi

	if [[ $DEFAULT_DUMP_MODE == "fadump" ]]; then
		rebuild_fadump_initrd
	else
		rebuild_kdump_initrd
	fi
}

#$1: the files to be checked with IFS=' '
check_exist()
{
	for file in $1; do
		if [[ ! -e $file ]]; then
			derror "Error: $file not found."
			return 1
		fi
	done
}

#$1: the files to be checked with IFS=' '
check_executable()
{
	for file in $1; do
		if [[ ! -x $file ]]; then
			derror "Error: $file is not executable."
			return 1
		fi
	done
}

backup_default_initrd()
{
	ddebug "backup default initrd: $DEFAULT_INITRD"

	if [[ ! -f $DEFAULT_INITRD ]]; then
		return
	fi

	if [[ ! -e $DEFAULT_INITRD_BAK ]]; then
		dinfo "Backing up $DEFAULT_INITRD before rebuild."
		# save checksum to verify before restoring
		sha1sum "$DEFAULT_INITRD" > "$INITRD_CHECKSUM_LOCATION"
		if ! cp "$DEFAULT_INITRD" "$DEFAULT_INITRD_BAK"; then
			dwarn "WARNING: failed to backup $DEFAULT_INITRD."
			rm -f -- "$INITRD_CHECKSUM_LOCATION"
			rm -f -- "$DEFAULT_INITRD_BAK"
		fi
	fi
}

restore_default_initrd()
{
	ddebug "restore default initrd: $DEFAULT_INITRD"

	if [[ ! -f $DEFAULT_INITRD ]]; then
		return
	fi

	# If a backup initrd exists, we must be switching back from
	# fadump to kdump. Restore the original default initrd.
	if [[ -f $DEFAULT_INITRD_BAK ]] && [[ -f $INITRD_CHECKSUM_LOCATION ]]; then
		# verify checksum before restoring
		backup_checksum=$(sha1sum "$DEFAULT_INITRD_BAK" | awk '{ print $1 }')
		default_checksum=$(awk '{ print $1 }' "$INITRD_CHECKSUM_LOCATION")
		if [[ $default_checksum != "$backup_checksum" ]]; then
			dwarn "WARNING: checksum mismatch! Can't restore original initrd.."
		else
			rm -f $INITRD_CHECKSUM_LOCATION
			if mv "$DEFAULT_INITRD_BAK" "$DEFAULT_INITRD"; then
				derror "Restoring original initrd as fadump mode is disabled."
				sync
			fi
		fi
	fi
}

check_config()
{
	local -A _opt_rec
	while read -r config_opt config_val; do
		case "$config_opt" in
		dracut_args)
			if [[ $config_val == *--mount* ]]; then
				if [[ $(echo "$config_val" | grep -o "\-\-mount" | wc -l) -ne 1 ]]; then
					derror 'Multiple mount targets specified in one "dracut_args".'
					return 1
				fi
				config_opt=_target
			fi
			;;
		raw)
			if [[ -d "/proc/device-tree/ibm,opal/dump" ]]; then
				dwarn "WARNING: Won't capture opalcore when 'raw' dump target is used."
			fi
			config_opt=_target
			;;
		ext[234] | minix | btrfs | xfs | nfs | ssh | virtiofs)
			config_opt=_target
			;;
		sshkey | path | core_collector | kdump_post | kdump_pre | extra_bins | extra_modules | failure_action | default | final_action | force_rebuild | force_no_rebuild | fence_kdump_args | fence_kdump_nodes | auto_reset_crashkernel) ;;

		net | options | link_delay | disk_timeout | debug_mem_level | blacklist)
			derror "Deprecated kdump config option: $config_opt. Refer to kdump.conf manpage for alternatives."
			return 1
			;;
		'')
			continue
			;;
		*)
			derror "Invalid kdump config option $config_opt"
			return 1
			;;
		esac

		if [[ -z $config_val ]]; then
			derror "Invalid kdump config value for option '$config_opt'"
			return 1
		fi

		if [[ -n ${_opt_rec[$config_opt]} ]]; then
			if [[ $config_opt == _target ]]; then
				derror "More than one dump targets specified"
			else
				derror "Duplicated kdump config value of option $config_opt"
			fi
			return 1
		fi
		_opt_rec[$config_opt]="$config_val"
	done <<< "$(kdump_read_conf)"

	check_failure_action_config || return 1
	check_final_action_config || return 1
	check_fence_kdump_config || return 1

	return 0
}

# get_pcs_cluster_modified_files <image timestamp>
# return list of modified file for fence_kdump modified in Pacemaker cluster
get_pcs_cluster_modified_files()
{
	local time_stamp
	local modified_files

	is_generic_fence_kdump && return 1
	is_pcs_fence_kdump || return 1

	time_stamp=$(pcs cluster cib | xmllint --xpath 'string(/cib/@cib-last-written)' - | xargs -0 date +%s --date)

	if [[ -n $time_stamp ]] && [[ $time_stamp -gt $image_time ]]; then
		modified_files="cluster-cib"
	fi

	if [[ -f $FENCE_KDUMP_CONFIG_FILE ]]; then
		time_stamp=$(stat -c "%Y" "$FENCE_KDUMP_CONFIG_FILE")
		if [[ $time_stamp -gt $image_time ]]; then
			modified_files="$modified_files $FENCE_KDUMP_CONFIG_FILE"
		fi
	fi

	echo "$modified_files"
}

setup_initrd()
{
	if ! prepare_kdump_bootinfo; then
		derror "failed to prepare for kdump bootinfo."
		return 1
	fi

	DEFAULT_INITRD_BAK="$KDUMP_BOOTDIR/.$(basename "$DEFAULT_INITRD").default"
	INITRD_CHECKSUM_LOCATION="$DEFAULT_INITRD_BAK.checksum"
	if [[ $DEFAULT_DUMP_MODE == "fadump" ]]; then
		TARGET_INITRD="$DEFAULT_INITRD"

		# backup initrd for reference before replacing it
		# with fadump aware initrd
		backup_default_initrd
	else
		TARGET_INITRD="$KDUMP_INITRD"

		# check if a backup of default initrd exists. If yes,
		# it signifies a switch from fadump mode. So, restore
		# the backed up default initrd.
		restore_default_initrd
	fi
}

check_files_modified()
{
	local modified_files=""

	#also rebuild when Pacemaker cluster conf is changed and fence kdump is enabled.
	modified_files=$(get_pcs_cluster_modified_files)

	EXTRA_BINS=$(kdump_get_conf_val kdump_post)
	CHECK_FILES=$(kdump_get_conf_val kdump_pre)
	HOOKS="/etc/kdump/post.d/ /etc/kdump/pre.d/"
	if [[ -d /etc/kdump/post.d ]]; then
		for file in /etc/kdump/post.d/*; do
			if [[ -x $file ]]; then
				POST_FILES="$POST_FILES $file"
			fi
		done
	fi
	if [[ -d /etc/kdump/pre.d ]]; then
		for file in /etc/kdump/pre.d/*; do
			if [[ -x $file ]]; then
				PRE_FILES="$PRE_FILES $file"
			fi
		done
	fi
	HOOKS="$HOOKS $POST_FILES $PRE_FILES"
	CORE_COLLECTOR=$(kdump_get_conf_val core_collector | awk '{print $1}')
	CORE_COLLECTOR=$(type -P "$CORE_COLLECTOR")
	# POST_FILES and PRE_FILES are already checked against executable, need not to check again.
	EXTRA_BINS="$EXTRA_BINS $CHECK_FILES"
	CHECK_FILES=$(kdump_get_conf_val extra_bins)
	EXTRA_BINS="$EXTRA_BINS $CHECK_FILES"
	files="$KDUMP_CONFIG_FILE $KDUMP_KERNEL $EXTRA_BINS $CORE_COLLECTOR"
	[[ -e /etc/fstab ]] && files="$files /etc/fstab"

	# Check for any updated extra module
	EXTRA_MODULES="$(kdump_get_conf_val extra_modules)"
	if [[ -n $EXTRA_MODULES ]]; then
		if [[ -e /lib/modules/$KDUMP_KERNELVER/modules.dep ]]; then
			files="$files /lib/modules/$KDUMP_KERNELVER/modules.dep"
		fi
		for _module in $EXTRA_MODULES; do
			if _module_file="$(modinfo --set-version "$KDUMP_KERNELVER" --filename "$_module" 2> /dev/null)"; then
				files="$files $_module_file"
				for _dep_modules in $(modinfo -F depends "$_module" | tr ',' ' '); do
					files="$files $(modinfo --set-version "$KDUMP_KERNELVER" --filename "$_dep_modules" 2> /dev/null)"
				done
			else
				# If it's not a module nor builtin, give an error
				if ! (modprobe --set-version "$KDUMP_KERNELVER" --dry-run "$_module" &> /dev/null); then
					dwarn "Module $_module not found"
				fi
			fi
		done
	fi

	# HOOKS is mandatory and need to check the modification time
	files="$files $HOOKS"
	is_lvm2_thinp_dump_target && files="$files $LVM_CONF"
	check_exist "$files" && check_executable "$EXTRA_BINS" || return 2

	for file in $files; do
		if [[ -e $file ]]; then
			time_stamp=$(stat -c "%Y" "$file")
			if [[ $time_stamp -gt $image_time ]]; then
				modified_files="$modified_files $file"
			fi
			if [[ -L $file ]]; then
				file=$(readlink -m "$file")
				time_stamp=$(stat -c "%Y" "$file")
				if [[ $time_stamp -gt $image_time ]]; then
					modified_files="$modified_files $file"
				fi
			fi
		else
			dwarn "$file doesn't exist"
		fi
	done

	if [[ -n $modified_files ]]; then
		dinfo "Detected change(s) in the following file(s): $modified_files"
		return 1
	fi

	return 0
}

check_drivers_modified()
{
	local _target _new_drivers _old_drivers _module_name _module_filename

	# If it's dump target is on block device, detect the block driver
	_target=$(get_block_dump_target)
	if [[ -n $_target ]]; then
		_record_block_drivers()
		{
			local _drivers
			_drivers=$(udevadm info -a "/dev/block/$1" | sed -n 's/\s*DRIVERS=="\(\S\+\)"/\1/p')
			for _driver in $_drivers; do
				if ! [[ " $_new_drivers " == *" $_driver "* ]]; then
					_new_drivers="$_new_drivers $_driver"
				fi
			done

			ddebug "MAJ:MIN=$1 drivers='$_drivers'"
		}
		check_block_and_slaves_all _record_block_drivers "$(get_maj_min "$_target")"
	fi

	# Include watchdog drivers if watchdog module is not omitted
	is_dracut_mod_omitted watchdog || _new_drivers+=" $(get_watchdog_drvs)"
	[[ -z $_new_drivers ]] && return 0

	if is_fadump_capable; then
		_old_drivers="$(lsinitrd "$TARGET_INITRD" -f /usr/lib/dracut/fadump-kernel-modules.txt | tr '\n' ' ')"
	else
		_old_drivers="$(lsinitrd "$TARGET_INITRD" -f /usr/lib/dracut/hostonly-kernel-modules.txt | tr '\n' ' ')"
	fi

	ddebug "Modules required for kdump: '$_new_drivers'"
	ddebug "Modules included in old initramfs: '$_old_drivers'"
	for _driver in $_new_drivers; do
		# Skip deprecated/invalid driver name or built-in module
		_module_name=$(modinfo --set-version "$KDUMP_KERNELVER" -F name "$_driver" 2> /dev/null)
		_module_filename=$(modinfo --set-version "$KDUMP_KERNELVER" -n "$_driver" 2> /dev/null)
		if [[ -z $_module_name ]] || [[ -z $_module_filename ]] || [[ $_module_filename == *"(builtin)"* ]]; then
			continue
		fi
		if ! [[ " $_old_drivers " == *" $_module_name "* ]]; then
			dinfo "Detected change in block device driver, new loaded module: $_module_name"
			return 1
		fi
	done
}

check_fs_modified()
{
	local _old_dev _old_mntpoint _old_fstype
	local _new_dev _new_mntpoint _new_fstype
	local _target _dracut_args

	# No need to check in case of mount target specified via "dracut_args".
	if is_mount_in_dracut_args; then
		return 0
	fi

	# No need to check in case of raw target.
	# Currently we do not check also if ssh/nfs/virtiofs/thinp target is specified
	if is_ssh_dump_target || is_nfs_dump_target || is_raw_dump_target ||
		is_virtiofs_dump_target || is_lvm2_thinp_dump_target; then
		return 0
	fi

	_target=$(get_block_dump_target)
	_new_fstype=$(get_fs_type_from_target "$_target")
	if [[ -z $_target ]] || [[ -z $_new_fstype ]]; then
		derror "Dump target is invalid"
		return 2
	fi

	ddebug "_target=$_target _new_fstype=$_new_fstype"
	_new_dev=$(kdump_get_persistent_dev "$_target")
	if [[ -z $_new_dev ]]; then
		perror "Get persistent device name failed"
		return 2
	fi

	_new_mntpoint="$(get_kdump_mntpoint_from_target "$_target")"
	_dracut_args=$(lsinitrd "$TARGET_INITRD" -f usr/lib/dracut/build-parameter.txt)
	if [[ -z $_dracut_args ]]; then
		dwarn "Warning: No dracut arguments found in initrd"
		return 0
	fi

	# if --mount argument present then match old and new target, mount
	# point and file system. If any of them mismatches then rebuild
	if echo "$_dracut_args" | grep -q "\-\-mount"; then
		# shellcheck disable=SC2046
		set -- $(echo "$_dracut_args" | awk -F "--mount '" '{print $2}' | cut -d' ' -f1,2,3)
		_old_dev=$1
		_old_mntpoint=$2
		_old_fstype=$3
		[[ $_new_dev == "$_old_dev" && $_new_mntpoint == "$_old_mntpoint" && $_new_fstype == "$_old_fstype" ]] && return 0
	# otherwise rebuild if target device is not a root device
	else
		[[ $_target == "$(get_root_fs_device)" ]] && return 0
	fi

	dinfo "Detected change in File System"
	return 1
}

# returns 0 if system is not modified
# returns 1 if system is modified
# returns 2 if system modification is invalid
check_system_modified()
{
	local ret
	local CONF_ERROR=2
	local CONF_MODIFY=1
	local CONF_NO_MODIFY=0
	local conf_status=$CONF_NO_MODIFY

	[[ -f $TARGET_INITRD ]] || return 1

	for _func in check_files_modified check_fs_modified check_drivers_modified; do
		$_func
		ret=$?
		# return immediately if an error occurred.
		[[ $ret -eq "$CONF_ERROR" ]] && return "$ret"
		[[ $ret -eq "$CONF_MODIFY" ]] && { conf_status="$CONF_MODIFY"; }
	done

	return $conf_status
}

check_rebuild()
{
	local capture_capable_initrd="1"
	local force_rebuild force_no_rebuild
	local ret system_modified="0"

	setup_initrd || return 1

	force_no_rebuild=$(kdump_get_conf_val force_no_rebuild)
	force_no_rebuild=${force_no_rebuild:-0}
	if [[ $force_no_rebuild != "0" ]] && [[ $force_no_rebuild != "1" ]]; then
		derror "Error: force_no_rebuild value is invalid"
		return 1
	fi

	force_rebuild=$(kdump_get_conf_val force_rebuild)
	force_rebuild=${force_rebuild:-0}
	if [[ $force_rebuild != "0" ]] && [[ $force_rebuild != "1" ]]; then
		derror "Error: force_rebuild value is invalid"
		return 1
	fi

	if [[ $force_no_rebuild == "1" && $force_rebuild == "1" ]]; then
		derror "Error: force_rebuild and force_no_rebuild are enabled simultaneously in kdump.conf"
		return 1
	fi

	# Will not rebuild kdump initrd
	if [[ $force_no_rebuild == "1" ]]; then
		return 0
	fi

	#check to see if dependent files has been modified
	#since last build of the image file
	if [[ -f $TARGET_INITRD ]]; then
		image_time=$(stat -c "%Y" "$TARGET_INITRD" 2> /dev/null)

		#in case of fadump mode, check whether the default/target
		#initrd is already built with dump capture capability
		if [[ $DEFAULT_DUMP_MODE == "fadump" ]]; then
			capture_capable_initrd=$(lsinitrd -f $DRACUT_MODULES_FILE "$TARGET_INITRD" | grep -c -e ^kdumpbase$ -e ^zz-fadumpinit$)
		fi
	fi

	check_system_modified
	ret=$?
	if [[ $ret -eq 2 ]]; then
		return 1
	elif [[ $ret -eq 1 ]]; then
		system_modified="1"
	fi

	if [[ $image_time -eq 0 ]]; then
		dinfo "No kdump initial ramdisk found."
	elif [[ $capture_capable_initrd == "0" ]]; then
		dinfo "Rebuild $TARGET_INITRD with dump capture support"
	elif [[ $force_rebuild != "0" ]]; then
		dinfo "Force rebuild $TARGET_INITRD"
	elif [[ $system_modified != "0" ]]; then
		:
	else
		return 0
	fi

	dinfo "Rebuilding $TARGET_INITRD"
	rebuild_initrd
}

# On ppc64le LPARs, the keys trusted by firmware do not end up in
# .builtin_trusted_keys. So instead, add the key to the .ima keyring
function load_kdump_kernel_key()
{
	# this is only called inside is_secure_boot_enforced,
	# no need to retest

        # this is only required if DT /ibm,secure-boot is a file.
        # if it is a dir, we are on OpenPower and don't need this.
        if ! [[ -f /proc/device-tree/ibm,secure-boot ]]; then
                return
        fi

	keyctl padd asymmetric "" %:.ima < "/usr/share/doc/kernel-keys/$KDUMP_KERNELVER/kernel-signing-ppc.cer"
}

# Load the kdump kernel specified in /etc/sysconfig/kdump
# If none is specified, try to load a kdump kernel with the same version
# as the currently running kernel.
load_kdump()
{
	local uki

	KEXEC_ARGS=$(prepare_kexec_args "${KEXEC_ARGS}")
	KDUMP_COMMANDLINE=$(prepare_cmdline "${KDUMP_COMMANDLINE}" "${KDUMP_COMMANDLINE_REMOVE}" "${KDUMP_COMMANDLINE_APPEND}")

	if is_uki "$KDUMP_KERNEL"; then
		uki=$KDUMP_KERNEL
		KDUMP_KERNEL=$KDUMP_TMPDIR/vmlinuz
		objcopy -O binary --only-section .linux "$uki" "$KDUMP_KERNEL"
		sync -f "$KDUMP_KERNEL"
		# Make sure the temp file has the correct SELinux label.
		# Otherwise starting the kdump.service will fail.
		chcon -t boot_t "$KDUMP_KERNEL"
	fi

	ddebug "$KEXEC $KEXEC_ARGS $standard_kexec_args --command-line=$KDUMP_COMMANDLINE --initrd=$TARGET_INITRD $KDUMP_KERNEL"

	# shellcheck disable=SC2086
	$KEXEC $KEXEC_ARGS $standard_kexec_args \
		--command-line="$KDUMP_COMMANDLINE" \
		--initrd="$TARGET_INITRD" "$KDUMP_KERNEL"

	if [[ $? == 0 ]]; then
		dinfo "kexec: loaded kdump kernel"
		return 0
	else
		derror "kexec: failed to load kdump kernel"
		return 1
	fi
}

check_ssh_config()
{
	local SSH_TARGET

	while read -r config_opt config_val; do
		case "$config_opt" in
		sshkey)
			# remove inline comments after the end of a directive.
			if [[ -f $config_val ]]; then
				# canonicalize the path
				SSH_KEY_LOCATION=$(/usr/bin/readlink -m "$config_val")
			else
				dwarn "WARNING: '$config_val' doesn't exist, using default value '$SSH_KEY_LOCATION'"
			fi
			;;
		path)
			SAVE_PATH=$config_val
			;;
		ssh)
			DUMP_TARGET=$config_val
			;;
		*) ;;

		esac
	done <<< "$(kdump_read_conf)"

	#make sure they've configured kdump.conf for ssh dumps
	SSH_TARGET=$(echo -n "$DUMP_TARGET" | sed -n '/.*@/p')
	if [[ -z $SSH_TARGET ]]; then
		return 1
	fi
	return 0
}

# ipv6 host address may takes a long time to be ready.
# Instead of checking against ipv6 address, we just check the network reachable
# by the return val of 'ssh'
check_and_wait_network_ready()
{
	local start_time
	local warn_once=1
	local cur
	local diff
	local retval
	local errmsg

	start_time=$(date +%s)
	while true; do
		errmsg=$(ssh -i "$SSH_KEY_LOCATION" -o BatchMode=yes "$DUMP_TARGET" mkdir -p "$SAVE_PATH" 2>&1)
		retval=$?

		# ssh exits with the exit status of the remote command or with 255 if an error occurred
		if [[ $retval -eq 0 ]]; then
			return 0
		elif [[ $retval -ne 255 ]]; then
			derror "Could not create $DUMP_TARGET:$SAVE_PATH, you should check the privilege on server side"
			return 1
		fi

		# if server removes the authorized_keys or, no /root/.ssh/kdump_id_rsa
		ddebug "$errmsg"
		if echo "$errmsg" | grep -q "Permission denied\|No such file or directory\|Host key verification failed"; then
			derror "Could not create $DUMP_TARGET:$SAVE_PATH, you probably need to run \"kdumpctl propagate\""
			return 1
		fi

		if [[ $warn_once -eq 1 ]]; then
			dwarn "Network dump target is not usable, waiting for it to be ready..."
			warn_once=0
		fi

		cur=$(date +%s)
		diff=$((cur - start_time))
		# 60s time out
		if [[ $diff -gt 180 ]]; then
			break
		fi
		sleep 1
	done

	dinfo "Could not create $DUMP_TARGET:$SAVE_PATH, ipaddr is not ready yet. You should check network connection"
	return 1
}

check_ssh_target()
{
	check_and_wait_network_ready
}

propagate_ssh_key()
{
	if ! check_ssh_config; then
		derror "No ssh config specified in $KDUMP_CONFIG_FILE.  Can't propagate"
		exit 1
	fi

	local KEYFILE=$SSH_KEY_LOCATION
	local errmsg="Failed to propagate ssh key"

	#Check to see if we already created key, if not, create it.
	if [[ -f $KEYFILE ]]; then
		dinfo "Using existing keys..."
	else
		dinfo "Generating new ssh keys... "
		/usr/bin/ssh-keygen -t rsa -f "$KEYFILE" -N "" 2>&1 > /dev/null
		dinfo "done."
	fi

	#now find the target ssh user and server to contact.
	SSH_USER=$(echo "$DUMP_TARGET" | cut -d@ -f1)
	SSH_SERVER=$(echo "$DUMP_TARGET" | sed -e's/\(.*@\)\(.*$\)/\2/')

	#now send the found key to the found server
	ssh-copy-id -i "$KEYFILE" "$SSH_USER@$SSH_SERVER"
	RET=$?
	if [[ $RET == 0 ]]; then
		dinfo "$KEYFILE has been added to ~$SSH_USER/.ssh/authorized_keys on $SSH_SERVER"
		return 0
	else
		derror "$errmsg, $KEYFILE failed in transfer to $SSH_SERVER"
		exit 1
	fi
}

show_reserved_mem()
{
	local mem
	local mem_mb

	mem=$(get_reserved_mem_size)
	mem_mb=$((mem / 1024 / 1024))

	dinfo "Reserved ${mem_mb}MB memory for crash kernel"
}

save_raw()
{
	local kdump_dir
	local raw_target

	raw_target=$(kdump_get_conf_val raw)
	[[ -z $raw_target ]] && return 0
	[[ -b $raw_target ]] || {
		derror "raw partition $raw_target not found"
		return 1
	}
	check_fs=$(lsblk --nodeps -npo FSTYPE "$raw_target")
	if [[ $(echo "$check_fs" | wc -w) -ne 0 ]]; then
		dwarn "Warning: Detected '$check_fs' signature on $raw_target, data loss is expected."
		return 0
	fi
	kdump_dir=$(kdump_get_conf_val path)
	if [[ -z ${kdump_dir} ]]; then
		coredir="/var/crash/$(date +"%Y-%m-%d-%H:%M")"
	else
		coredir="${kdump_dir}/$(date +"%Y-%m-%d-%H:%M")"
	fi

	mkdir -p "$coredir"
	[[ -d $coredir ]] || {
		derror "failed to create $coredir"
		return 1
	}
	if makedumpfile -R "$coredir/vmcore" < "$raw_target" > /dev/null 2>&1; then
		# dump found
		dinfo "Dump saved to $coredir/vmcore"
		# wipe makedumpfile header
		dd if=/dev/zero of="$raw_target" bs=1b count=1 2> /dev/null
	else
		rm -rf "$coredir"
	fi

	return 0
}

local_fs_dump_target()
{
	local _target

	if _target=$(grep -E "^ext[234]|^xfs|^btrfs|^minix" /etc/kdump.conf); then
		echo "$_target" | awk '{print $2}'
	fi
}

path_to_be_relabeled()
{
	local _path _target _mnt="/" _rmnt

	if is_user_configured_dump_target; then
		if is_mount_in_dracut_args; then
			return
		fi

		_target=$(local_fs_dump_target)
		if [[ -n $_target ]]; then
			_mnt=$(get_mntpoint_from_target "$_target")
			if ! is_mounted "$_mnt"; then
				return
			fi
		else
			return
		fi
	fi

	_path=$(get_save_path)
	# if $_path is masked by other mount, we will not relabel it.
	_rmnt=$(df "$_mnt/$_path" 2> /dev/null | tail -1 | awk '{ print $NF }')
	if [[ $_rmnt == "$_mnt" ]]; then
		echo "$_mnt/$_path"
	fi
}

selinux_relabel()
{
	local _path _i _attr

	_path=$(path_to_be_relabeled)
	if [[ -z $_path ]] || ! [[ -d $_path ]]; then
		return
	fi

	while IFS= read -r -d '' _i; do
		_attr=$(getfattr -m "security.selinux" "$_i" 2> /dev/null)
		if [[ -z $_attr ]]; then
			restorecon "$_i"
		fi
	done < <(find "$_path" -print0)
}

check_fence_kdump_config()
{
	local hostname
	local ipaddrs
	local nodes

	hostname=$(hostname)
	ipaddrs=$(hostname -I)
	nodes=$(kdump_get_conf_val "fence_kdump_nodes")

	for node in $nodes; do
		if [[ $node == "$hostname" ]]; then
			derror "Option fence_kdump_nodes cannot contain $hostname"
			return 1
		fi
		# node can be ipaddr
		if echo "$ipaddrs " | grep -q "$node "; then
			derror "Option fence_kdump_nodes cannot contain $node"
			return 1
		fi
	done

	return 0
}

check_dump_feasibility()
{
	if [[ $DEFAULT_DUMP_MODE == "fadump" ]]; then
		return 0
	fi

	check_kdump_feasibility
}

start_fadump()
{
	echo 1 > "$FADUMP_REGISTER_SYS_NODE"
	if ! is_kernel_loaded "fadump"; then
		derror "fadump: failed to register"
		return 1
	fi

	dinfo "fadump: registered successfully"
	return 0
}

start_dump()
{
	# On secure boot enabled Power systems, load kernel signing key on .ima for signature
	# verification using kexec file based syscall.
	if [[ "$(uname -m)" == ppc64le ]] && is_secure_boot_enforced; then
		load_kdump_kernel_key
	fi

	if [[ $DEFAULT_DUMP_MODE == "fadump" ]]; then
		start_fadump
	else
		load_kdump
	fi
}

check_failure_action_config()
{
	local default_option
	local failure_action
	local option="failure_action"

	default_option=$(kdump_get_conf_val default)
	failure_action=$(kdump_get_conf_val failure_action)

	if [[ -z $failure_action ]] && [[ -z $default_option ]]; then
		return 0
	elif [[ -n $failure_action ]] && [[ -n $default_option ]]; then
		derror "Cannot specify 'failure_action' and 'default' option together"
		return 1
	fi

	if [[ -n $default_option ]]; then
		option="default"
		failure_action="$default_option"
	fi

	case "$failure_action" in
	reboot | halt | poweroff | shell | dump_to_rootfs)
		return 0
		;;
	*)
		dinfo $"Usage kdump.conf: $option {reboot|halt|poweroff|shell|dump_to_rootfs}"
		return 1
		;;
	esac
}

check_final_action_config()
{
	local final_action

	final_action=$(kdump_get_conf_val final_action)
	if [[ -z $final_action ]]; then
		return 0
	else
		case "$final_action" in
		reboot | halt | poweroff)
			return 0
			;;
		*)
			dinfo $"Usage kdump.conf: final_action {reboot|halt|poweroff}"
			return 1
			;;
		esac
	fi
}

start()
{
	if ! check_dump_feasibility; then
		derror "Starting kdump: [FAILED]"
		return 1
	fi

	if ! check_config; then
		derror "Starting kdump: [FAILED]"
		return 1
	fi

	if sestatus 2> /dev/null | grep -q "SELinux status.*enabled"; then
		selinux_relabel
	fi

	if ! save_raw; then
		derror "Starting kdump: [FAILED]"
		return 1
	fi

	if [[ $DEFAULT_DUMP_MODE == "kdump" ]] && is_kernel_loaded "kdump"; then
		dwarn "Kdump already running: [WARNING]"
		return 0
	fi

	if check_ssh_config; then
		if ! check_ssh_target; then
			derror "Starting kdump: [FAILED]"
			return 1
		fi
	fi

	if ! check_rebuild; then
		derror "Starting kdump: [FAILED]"
		return 1
	fi

	if ! start_dump; then
		derror "Starting kdump: [FAILED]"
		return 1
	fi

	dinfo "Starting kdump: [OK]"
}

reload()
{
	if ! is_kernel_loaded "$DEFAULT_DUMP_MODE"; then
		dwarn "Kdump was not running: [WARNING]"
	fi

	if [[ $DEFAULT_DUMP_MODE == "fadump" ]]; then
		reload_fadump
		return
	else
		if ! stop_kdump; then
			derror "Stopping kdump: [FAILED]"
			return 1
		fi
	fi

	dinfo "Stopping kdump: [OK]"

	if ! setup_initrd; then
		derror "Starting kdump: [FAILED]"
		return 1
	fi

	if ! start_dump; then
		derror "Starting kdump: [FAILED]"
		return 1
	fi

	dinfo "Starting kdump: [OK]"
}

stop_fadump()
{
	echo 0 > "$FADUMP_REGISTER_SYS_NODE"
	if is_kernel_loaded "fadump"; then
		derror "fadump: failed to unregister"
		return 1
	fi

	dinfo "fadump: unregistered successfully"
	return 0
}

stop_kdump()
{
	if is_secure_boot_enforced; then
		$KEXEC -s -p -u
	else
		$KEXEC -p -u
	fi

	# shellcheck disable=SC2181
	if [[ $? != 0 ]]; then
		derror "kexec: failed to unload kdump kernel"
		return 1
	fi

	dinfo "kexec: unloaded kdump kernel"
	return 0
}

reload_fadump()
{
	if echo 1 > "$FADUMP_REGISTER_SYS_NODE"; then
		dinfo "fadump: re-registered successfully"
		return 0
	else
		# FADump could fail on older kernel where re-register
		# support is not enabled. Try stop/start from userspace
		# to handle such scenario.
		if stop_fadump; then
			start_fadump
			return
		fi
	fi

	return 1
}

stop()
{
	if [[ $DEFAULT_DUMP_MODE == "fadump" ]]; then
		stop_fadump
	else
		stop_kdump
	fi

	# shellcheck disable=SC2181
	if [[ $? != 0 ]]; then
		derror "Stopping kdump: [FAILED]"
		return 1
	fi

	dinfo "Stopping kdump: [OK]"
	return 0
}

rebuild()
{
	check_config || return 1

	if check_ssh_config; then
		if ! check_ssh_target; then
			return 1
		fi
	fi

	setup_initrd || return 1

	dinfo "Rebuilding $TARGET_INITRD"
	rebuild_initrd
}

check_vmlinux()
{
	# Use readelf to check if it's a valid ELF
	readelf -h "$1" &> /dev/null || return 1
}

get_vmlinux_size()
{
	local size=0 _msize

	while read -r _msize; do
		size=$((size + _msize))
	done <<< "$(readelf -l -W "$1" | awk '/^  LOAD/{print $6}' 2> /dev/stderr)"

	echo $size
}

try_decompress()
{
	# The obscure use of the "tr" filter is to work around older versions of
	# "grep" that report the byte offset of the line instead of the pattern.

	# Try to find the header ($1) and decompress from here
	for pos in $(tr "$1\n$2" "\n$2=" < "$4" | grep -abo "^$2"); do
		if ! type -P "$3" > /dev/null; then
			ddebug "Signiature detected but '$3' is missing, skip this decompressor"
			break
		fi

		pos=${pos%%:*}
		tail "-c+$pos" "$img" | $3 > "$5" 2> /dev/null
		if check_vmlinux "$5"; then
			ddebug "Kernel is extracted with '$3'"
			return 0
		fi
	done

	return 1
}

# Borrowed from linux/scripts/extract-vmlinux
get_kernel_size()
{
	# Prepare temp files:
	local tmp img=$1

	tmp="$KDUMP_TMPDIR/vmlinux"

	# Try to check if it's a vmlinux already
	check_vmlinux "$img" && get_vmlinux_size "$img" && return 0

	# That didn't work, so retry after decompression.
	try_decompress '\037\213\010' xy gunzip "$img" "$tmp" ||
		try_decompress '\3757zXZ\000' abcde unxz "$img" "$tmp" ||
		try_decompress 'BZh' xy bunzip2 "$img" "$tmp" ||
		try_decompress '\135\0\0\0' xxx unlzma "$img" "$tmp" ||
		try_decompress '\211\114\132' xy 'lzop -d' "$img" "$tmp" ||
		try_decompress '\002!L\030' xxx 'lz4 -d' "$img" "$tmp" ||
		try_decompress '(\265/\375' xxx unzstd "$img" "$tmp"

	# Finally check for uncompressed images or objects:
	[[ $? -eq 0 ]] && get_vmlinux_size "$tmp" && return 0

	# Fallback to use iomem
	local _size=0 _seg
	while read -r _seg; do
		_size=$((_size + 0x${_seg#*-} - 0x${_seg%-*}))
	done <<< "$(grep -E "Kernel (code|rodata|data|bss)" /proc/iomem | cut -d ":" -f 1)"
	echo $_size
}

do_estimate()
{
	local kdump_mods
	local -A large_mods
	local baseline
	local kernel_size mod_size initrd_size baseline_size runtime_size reserved_size estimated_size recommended_size _cryptsetup_overhead
	local size_mb=$((1024 * 1024))

	setup_initrd
	if [[ ! -f $TARGET_INITRD ]]; then
		derror "kdumpctl estimate: kdump initramfs is not built yet."
		exit 1
	fi

	kdump_mods="$(lsinitrd "$TARGET_INITRD" -f /usr/lib/dracut/hostonly-kernel-modules.txt | tr '\n' ' ')"
	baseline=$(kdump_get_arch_recommend_size)
	if [[ ${baseline: -1} == "M" ]]; then
		baseline=${baseline%M}
	elif [[ ${baseline: -1} == "G" ]]; then
		baseline=$((${baseline%G} * 1024))
	elif [[ ${baseline: -1} == "T" ]]; then
		baseline=$((${baseline%Y} * 1048576))
	fi

	# The default pre-reserved crashkernel value
	baseline_size=$((baseline * size_mb))
	# Current reserved crashkernel size
	reserved_size=$(get_reserved_mem_size)
	# A pre-estimated value for userspace usage and kernel
	# runtime allocation, 64M should good for most cases
	runtime_size=$((64 * size_mb))
	# Kernel image size
	kernel_size=$(get_kernel_size "$KDUMP_KERNEL")
	# Kdump initramfs size
	initrd_size=$(du -b "$TARGET_INITRD" | awk '{print $1}')
	# Kernel modules static size after loaded
	mod_size=0
	while read -r _name _size _; do
		if [[ " $kdump_mods " != *" $_name "* ]]; then
			continue
		fi
		mod_size=$((mod_size + _size))

		# Mark module with static size larger than 2M as large module
		if [[ $((_size / size_mb)) -ge 1 ]]; then
			large_mods[$_name]=$_size
		fi
	done <<< "$(< /proc/modules)"

	# Extra memory usage required for LUKS2 decryption
	crypt_size=0
	for _dev in $(get_all_kdump_crypt_dev); do
		_crypt_info=$(cryptsetup luksDump "/dev/block/$_dev")
		[[ $(echo "$_crypt_info" | sed -n "s/^Version:\s*\(.*\)/\1/p") == "2" ]] || continue
		for _mem in $(echo "$_crypt_info" | sed -n "s/\sMemory:\s*\(.*\)/\1/p" | sort -n -r); do
			crypt_size=$((crypt_size + _mem * 1024))
			break
		done
	done

	if [[ $crypt_size -ne 0 ]]; then
		if [[ $(uname -m) == aarch64 ]]; then
			_cryptsetup_overhead=50
		else
			_cryptsetup_overhead=20
		fi

		crypt_size=$((crypt_size + _cryptsetup_overhead * size_mb))
		echo -e "Encrypted kdump target requires extra memory, assuming using the keyslot with maximum memory requirement\n"
	fi

	estimated_size=$((kernel_size + mod_size + initrd_size + runtime_size + crypt_size))
	if [[ $baseline_size -gt $estimated_size ]]; then
		recommended_size=$baseline_size
	else
		recommended_size=$estimated_size
	fi

	echo "Reserved crashkernel:    $((reserved_size / size_mb))M"
	echo "Recommended crashkernel: $((recommended_size / size_mb))M"
	echo
	echo "Kernel image size:   $((kernel_size / size_mb))M"
	echo "Kernel modules size: $((mod_size / size_mb))M"
	echo "Initramfs size:      $((initrd_size / size_mb))M"
	echo "Runtime reservation: $((runtime_size / size_mb))M"
	[[ $crypt_size -ne 0 ]] &&
		echo "LUKS required size:  $((crypt_size / size_mb))M"
	echo -n "Large modules:"
	if [[ ${#large_mods[@]} -eq 0 ]]; then
		echo " <none>"
	else
		echo ""
		for _mod in "${!large_mods[@]}"; do
			echo "    $_mod: ${large_mods[$_mod]}"
		done
	fi

	if [[ $reserved_size -lt $recommended_size ]]; then
		echo "WARNING: Current crashkernel size is lower than recommended size $((recommended_size / size_mb))M."
	fi
}

get_default_crashkernel()
{
	local _dump_mode=$1

	kdump_get_arch_recommend_crashkernel "$_dump_mode"
}

# Read kernel cmdline parameter for a specific kernel
# $1: kernel path, DEFAULT or kernel path, ALL not accepted
# $2: kernel cmldine parameter
get_grub_kernel_boot_parameter()
{
	local _kernel_path=$1 _para=$2

	[[ $_kernel_path == ALL ]] && derror "kernel_path=ALL invalid for get_grub_kernel_boot_parameter" && return 1
	grubby --info="$_kernel_path" | sed -En -e "/^args=.*$/{s/^.*(\s|\")${_para}=(\S*).*\"$/\2/p;q}"
}

# get dump mode by fadump value
# return
#  - fadump, if fadump=on or fadump=nocma
#  - kdump, if fadump=off or empty fadump, return kdump
#  - error if otherwise
get_dump_mode_by_fadump_val()
{
	local _fadump_val=$1

	if [[ -z $_fadump_val ]] || [[ $_fadump_val == off ]]; then
		echo -n kdump
	elif [[ $_fadump_val == on ]] || [[ $_fadump_val == nocma ]]; then
		echo -n fadump
	else
		derror "invalid fadump=$_fadump_val"
		return 1
	fi
}

# get dump mode of a specific kernel
# based on its fadump kernel cmdline parameter
get_dump_mode_by_kernel()
{
	local _kernel_path=$1 _fadump_val _dump_mode

	_fadump_val=$(get_grub_kernel_boot_parameter "$_kernel_path" fadump)
	if _dump_mode=$(get_dump_mode_by_fadump_val "$_fadump_val"); then
		echo -n "$_dump_mode"
	else
		derror "failed to get dump mode for kernel $_kernel_path"
		exit
	fi
}

_filter_grubby_kernel_str()
{
	local _grubby_kernel_str=$1
	echo -n "$_grubby_kernel_str" | sed -n -e 's/^kernel="\(.*\)"/\1/p'
}

_find_kernel_path_by_release()
{
	local _release="$1" _grubby_kernel_str _kernel_path

	# Insert '/' before '+' to cope with grep's EREs
	_release=${_release//+/\\+}
	_grubby_kernel_str=$(grubby --info ALL | grep -E "^kernel=.*$_release(\/\w+)?\"$")
	_kernel_path=$(_filter_grubby_kernel_str "$_grubby_kernel_str")
	if [[ -z $_kernel_path ]]; then
		ddebug "kernel $_release doesn't exist"
		return 1
	fi
	echo -n "$_kernel_path"
}

_get_current_running_kernel_path()
{
	local _release _path

	_release=$(uname -r)
	if _path=$(_find_kernel_path_by_release "$_release"); then
		echo -n "$_path"
	else
		return 1
	fi
}

_update_kernel_cmdline()
{
	local _kernel_path=$1 _crashkernel=$2 _dump_mode=$3 _fadump_val=$4

	if is_ostree; then
		if rpm-ostree kargs | grep -q "crashkernel="; then
			rpm-ostree kargs --replace="crashkernel=$_crashkernel"
		else
			rpm-ostree kargs --append="crashkernel=$_crashkernel"
		fi
	else
		grubby --args "crashkernel=$_crashkernel" --update-kernel "$_kernel_path"
		if [[ $_dump_mode == kdump ]]; then
			grubby --remove-args="fadump" --update-kernel "$_kernel_path"
		else
			grubby --args="fadump=$_fadump_val" --update-kernel "$_kernel_path"
		fi
	fi
	[[ -f /etc/zipl.conf ]] && zipl > /dev/null
}

_valid_grubby_kernel_path()
{
	[[ -n "$1" ]] && grubby --info="$1" > /dev/null 2>&1
}

# return all the kernel paths given a grubby kernel-path
#
# $1: kernel path accepted by grubby, e.g. DEFAULT, ALL,
#     /boot/vmlinuz-`uname -r`
# return: kernel paths separated by space
_get_all_kernels_from_grubby()
{
	local _kernels _line _kernel_path _grubby_kernel_path=$1

	for _line in $(grubby --info "$_grubby_kernel_path" | grep "^kernel="); do
		_kernel_path=$(_filter_grubby_kernel_str "$_line")
		_kernels="$_kernels $_kernel_path"
	done
	echo -n "$_kernels"
}

GRUB_ETC_DEFAULT="/etc/default/grub"
# Update a kernel parameter in default grub conf
#
# If a value is specified, it will be inserted in the end. Otherwise it
# would remove given kernel parameter.
#
# Note this function doesn't address the following cases,
# 1. The kernel ignores everything on the command line after a '--'. So
#    simply adding the new entry to the end will fail if the cmdline
#    contains a --.
# 2. If the value for a parameter contains spaces it can be quoted using
#    double quotes, for example param="value with spaces". This will
#    break the [^[:space:]\"] regex for the value.
# 3. Dashes and underscores in the parameter name are equivalent. So
#    some_parameter and some-parameter are identical.
# 4. Some parameters, e.g. efivar_ssdt, can be given multiple times.
# 5. Some kernel parameters, e.g. quiet, doesn't have value
#
# $1: the name of the kernel command line parameter
# $2: new value. If empty, given parameter would be removed
_update_kernel_arg_in_grub_etc_default()
{
	local _para=$1 _val=$2 _para_val

	if [[ $(uname -m) == s390x ]]; then
		return
	fi

	if [[ -n $_val ]]; then
		_para_val="$_para=$_val"
	fi

	# Update the command line /etc/default/grub, i.e.
	# on the line that starts with 'GRUB_CMDLINE_LINUX=',
	#       1) remove $para=$val if the it's the first arg
	#       2) remove all occurences of $para=$val
	#       3) insert $_para_val to end
	#       4) remove duplicate spaces left over by 1) or 2) or 3)
	#       5) remove space at the beginning of the string left over by 1) or 2) or 3)
	#       6) remove space at the end of the string left over by 1) or 2) or 3)
	sed -i -E "/^GRUB_CMDLINE_LINUX=/ {
         s/\"${_para}=[^[:space:]\"]*/\"/g;
         s/[[:space:]]+${_para}=[^[:space:]\"]*/ /g;
         s/\"$/ ${_para_val}\"/
         s/[[:space:]]+/ /g;
         s/(\")[[:space:]]+/\1/g;
         s/[[:space:]]+(\")/\1/g;
         }" "$GRUB_ETC_DEFAULT"
}

# Read the kernel arg in default grub conf.

# Note reading a kernel parameter that doesn't have a value isn't supported.
#
# $1: the name of the kernel command line parameter
_read_kernel_arg_in_grub_etc_default()
{
	sed -n -E "s/^GRUB_CMDLINE_LINUX=.*[[:space:]\"]${1}=([^[:space:]\"]*).*$/\1/p" "$GRUB_ETC_DEFAULT"
}

reset_crashkernel()
{
	local _opt _val _dump_mode _fadump_val _reboot _grubby_kernel_path _kernel _kernels
	local _old_crashkernel _new_crashkernel _new_dump_mode _crashkernel_changed
	local _new_fadump_val _old_fadump_val _what_is_updated

	for _opt in "$@"; do
		case "$_opt" in
			--fadump=*)
				_val=${_opt#*=}
				if _dump_mode=$(get_dump_mode_by_fadump_val $_val); then
					_fadump_val=$_val
				else
					derror "failed to determine dump mode"
					exit
				fi
				;;
			--kernel=*)
				_val=${_opt#*=}
				if ! _valid_grubby_kernel_path $_val; then
					derror "Invalid $_opt, please specify a valid kernel path, ALL or DEFAULT"
					exit
				fi
				_grubby_kernel_path=$_val
				;;
			--reboot)
				_reboot=yes
				;;
			*)
				derror "$_opt not recognized"
				exit 1
				;;
		esac
	done

	# 1. OSTree systems use "rpm-ostree kargs" instead of grubby to manage kernel command
	#    line. --kernel=ALL doesn't make sense for OStree.
	# 2. We don't have any OSTree POWER systems so the dump mode is always kdump.
	# 3. "rpm-ostree kargs" would prompt the user to reboot the system after
	#    modifying the kernel command line so there is no need for kexec-tools
	#    to repeat it.
	if is_ostree; then
		_old_crashkernel=$(rpm-ostree kargs | sed -n -E 's/.*(^|\s)crashkernel=(\S*).*/\2/p')
		_new_dump_mode=kdump
		_new_crashkernel=$(kdump_get_arch_recommend_crashkernel "$_new_dump_mode")
		if [[ $_old_crashkernel != "$_new_crashkernel" ]]; then
			_update_kernel_cmdline "" "$_new_crashkernel" "$_new_dump_mode" ""
			if [[ $_reboot == yes ]]; then
				systemctl reboot
			fi
		fi
		return
	fi

	# For non-ppc64le systems, the dump mode is always kdump since only ppc64le
	# has FADump.
	if [[ -z $_dump_mode && $(uname -m) != ppc64le ]]; then
		_dump_mode=kdump
		_fadump_val=off
	fi

	# If the dump mode is determined, we can also know the default crashkernel value
	if [[ -n $_dump_mode ]]; then
		_crashkernel=$(kdump_get_arch_recommend_crashkernel "$_dump_mode")
	fi

	# If --kernel-path=ALL, update GRUB_CMDLINE_LINUX in /etc/default/grub.
	#
	# An exception case is when the ppc64le user doesn't specify the fadump value.
	# In this case, the dump mode would be determined by parsing the kernel
	# command line of the kernel(s) to be updated thus don't update GRUB_CMDLINE_LINUX.
	#
	# The following code has been simplified because of what has been done early,
	#   - set the dump mode as kdump for non-ppc64le cases
	#   - retrieved the default crashkernel value for given dump mode
	if [[ $_grubby_kernel_path == ALL && -n $_dump_mode ]]; then
		_update_kernel_arg_in_grub_etc_default crashkernel "$_crashkernel"
		# remove the fadump if fadump is disabled
		if [[ $_fadump_val == off ]]; then
			_fadump_val=""
		fi
		_update_kernel_arg_in_grub_etc_default fadump "$_fadump_val"
	fi

	# If kernel-path not specified, either
	#  - use KDUMP_KERNELVER if it's defined
	#  - use current running kernel
	if [[ -z $_grubby_kernel_path ]]; then
		if [[ -z $KDUMP_KERNELVER ]] ||
			! _kernel_path=$(_find_kernel_path_by_release "$KDUMP_KERNELVER"); then
					if ! _kernel_path=$(_get_current_running_kernel_path); then
						derror "no running kernel found"
						exit 1
					fi
		fi
		_kernels=$_kernel_path
	else
		_kernels=$(_get_all_kernels_from_grubby "$_grubby_kernel_path")
	fi

	for _kernel in $_kernels; do
		if [[ -z $_dump_mode ]]; then
			_new_dump_mode=$(get_dump_mode_by_kernel "$_kernel")
			_new_crashkernel=$(kdump_get_arch_recommend_crashkernel "$_new_dump_mode")
			_new_fadump_val=$(get_grub_kernel_boot_parameter "$_kernel" fadump)
		else
			_new_dump_mode=$_dump_mode
			_new_crashkernel=$_crashkernel
			_new_fadump_val=$_fadump_val
		fi

		_old_crashkernel=$(get_grub_kernel_boot_parameter "$_kernel" crashkernel)
		_old_fadump_val=$(get_grub_kernel_boot_parameter "$_kernel" fadump)
		[[ "$_new_fadump_val" == off ]] && _new_fadump_val=""
		if [[ $_old_crashkernel != "$_new_crashkernel" || $_old_fadump_val != "$_new_fadump_val" ]]; then
			_update_kernel_cmdline "$_kernel" "$_new_crashkernel" "$_new_dump_mode" "$_new_fadump_val"
			if [[ $_reboot != yes ]]; then
				if [[ $_old_crashkernel != "$_new_crashkernel" ]]; then
					_what_is_updated="Updated crashkernel=$_new_crashkernel"
				else
					# This case happens only when switching between fadump=on and fadump=nocma
					_what_is_updated="Updated fadump=$_new_fadump_val"
				fi
				dwarn "$_what_is_updated for kernel=$_kernel. Please reboot the system for the change to take effect."
			fi
			_crashkernel_changed=yes
		fi
	done

	if [[ $_reboot == yes && $_crashkernel_changed == yes ]]; then
		reboot
	fi
}

_is_bootloader_installed()
{
	if [[ $(uname -m) == s390x ]]; then
		test -f /etc/zipl.conf
	else
		test -f /boot/grub2/grub.cfg
	fi
}

_update_crashkernel()
{
	local _kernel _kver _dump_mode _old_default_crashkernel _new_default_crashkernel _fadump_val _msg

	_kernel=$1
	_dump_mode=$(get_dump_mode_by_kernel "$_kernel")
	_old_default_crashkernel=$(get_grub_kernel_boot_parameter "$_kernel" crashkernel)
	_kver=$(parse_kver_from_path "$_kernel")
	# The second argument is for the case of aarch64, where installing a 64k variant on a 4k kernel, or vice versa
	_new_default_crashkernel=$(kdump_get_arch_recommend_crashkernel "$_dump_mode" "$_kver")
	if [[ $_old_default_crashkernel != "$_new_default_crashkernel" ]]; then
		_fadump_val=$(get_grub_kernel_boot_parameter "$_kernel" fadump)
		if _update_kernel_cmdline "$_kernel" "$_new_default_crashkernel" "$_dump_mode" "$_fadump_val"; then
			_msg="For kernel=$_kernel, crashkernel=$_new_default_crashkernel now. Please reboot the system for the change to take effet."
			_msg+=" Note if you don't want kexec-tools to manage the crashkernel kernel parameter, please set auto_reset_crashkernel=no in /etc/kdump.conf."
			dinfo "$_msg"
		fi
	fi
}


# shellcheck disable=SC2154 # false positive when dereferencing an array
reset_crashkernel_after_update()
{
	local _kernel

	if ! _is_bootloader_installed; then
		return
	fi

	for _kernel in $(_get_all_kernels_from_grubby ALL); do
		_update_crashkernel "$_kernel"
	done
}

# read the value of an environ variable from given environ file path
#
# The environment variable entries in /proc/[pid]/environ are separated
# by null bytes instead of by spaces.
#
# $1: environment variable
# $2: environ file path
read_proc_environ_var()
{
	local _var=$1 _environ_path=$2
	sed -n -E "s/.*(^|\x00)${_var}=([^\x00]*).*/\2/p" < "$_environ_path"
}

_OSBUILD_ENVIRON_PATH='/proc/1/environ'
_is_osbuild()
{
	[[ $(read_proc_environ_var container "$_OSBUILD_ENVIRON_PATH") == bwrap-osbuild ]]
}

reset_crashkernel_for_installed_kernel()
{
	local _installed_kernel

	# During package install, only try to reset crashkernel for osbuild
	# thus to avoid calling grubby when installing os via anaconda
	if ! _is_bootloader_installed && ! _is_osbuild; then
		return
	fi

	if ! _installed_kernel=$(_find_kernel_path_by_release "$1"); then
		exit 1
	fi

	if _is_osbuild; then
		if ! grep -qs crashkernel= /etc/kernel/cmdline; then
			reset_crashkernel "--kernel=$_installed_kernel"
		fi
		return
	fi

	_update_crashkernel "$_installed_kernel"
}

if [[ ! -f $KDUMP_CONFIG_FILE ]]; then
	derror "Error: No kdump config file found!"
	exit 1
fi

main()
{
	# Determine if the dump mode is kdump or fadump
	determine_dump_mode

	case "$1" in
	start)
		if [[ -s /proc/vmcore ]]; then
			save_core
			reboot
		else
			start
		fi
		;;
	stop)
		stop
		;;
	status)
		EXIT_CODE=0
		is_kernel_loaded "$DEFAULT_DUMP_MODE"
		case "$?" in
		0)
			dinfo "Kdump is operational"
			EXIT_CODE=0
			;;
		1)
			dinfo "Kdump is not operational"
			EXIT_CODE=3
			;;
		esac
		exit $EXIT_CODE
		;;
	reload)
		reload
		;;
	restart)
		stop
		start
		;;
	rebuild)
		rebuild
		;;
	condrestart) ;;

	propagate)
		propagate_ssh_key
		;;
	showmem)
		show_reserved_mem
		;;
	estimate)
		do_estimate
		;;
	get-default-crashkernel)
		get_default_crashkernel "$2"
		;;
	reset-crashkernel)
		shift
		reset_crashkernel "$@"
		;;
	_reset-crashkernel-after-update)
		if [[ $(kdump_get_conf_val auto_reset_crashkernel) != no ]]; then
			reset_crashkernel_after_update
		fi
		;;
	_reset-crashkernel-for-installed_kernel)
		if [[ $(kdump_get_conf_val auto_reset_crashkernel) != no ]]; then
			reset_crashkernel_for_installed_kernel "$2"
		fi
		;;
	*)
		dinfo $"Usage: $0 {estimate|start|stop|status|restart|reload|rebuild|reset-crashkernel|propagate|showmem}"
		exit 1
		;;
	esac
}

# Other kdumpctl instances will block in queue, until this one exits
single_instance_lock

# To avoid fd 9 leaking, we invoke a subshell, close fd 9 and call main.
# So that fd isn't leaking when main is invoking a subshell.
(
	exec 9<&-
	main "$@"
)

Filemanager

Name Type Size Permission Actions
2to3 File 95 B 0755
ERROR! File 271.55 KB 0755
GET File 15.82 KB 0755
HEAD File 15.82 KB 0755
Mail File 1014.48 KB 0755
NO File 271.55 KB 0755
POST File 15.82 KB 0755
RCUpdate File 4.49 KB 0755
RCdaemon File 327.1 KB 0755
RcLicenseCP File 271.55 KB 0755
[ File 51.81 KB 0755
ab File 81.46 KB 0755
aclocal File 35.52 KB 0755
aclocal-1.16 File 35.52 KB 0755
acyclic File 15.3 KB 0755
addr2line File 27.93 KB 0755
alias File 33 B 0755
animate File 15.27 KB 0755
appstream-compose File 31.47 KB 0755
appstream-util File 116.57 KB 0755
apropos File 48.52 KB 0755
apropos.man-db File 48.52 KB 0755
ar File 56.19 KB 0755
arch File 31.66 KB 0755
aria_chk File 5.51 MB 0755
aria_dump_log File 5.3 MB 0755
aria_ftdump File 5.31 MB 0755
aria_pack File 5.34 MB 0755
aria_read_log File 5.46 MB 0755
arpaname File 15.3 KB 0755
arping File 27.42 KB 0755
as File 710.51 KB 0755
aserver File 39.66 KB 0755
aspell File 151.12 KB 0755
at File 56.62 KB 0755
atq File 56.62 KB 0755
atrm File 56.62 KB 0755
attr File 15.72 KB 0755
audit2allow File 14.71 KB 0755
audit2why File 14.71 KB 0755
aulast File 19.39 KB 0755
aulastlog File 15.34 KB 0755
ausyscall File 15.32 KB 0755
authselect File 43.68 KB 0755
autoconf File 14.42 KB 0755
autoheader File 8.33 KB 0755
autom4te File 31.43 KB 0755
automake File 251.93 KB 0755
automake-1.16 File 251.93 KB 0755
autopoint File 26.36 KB 0755
autoreconf File 20.57 KB 0755
autoscan File 16.72 KB 0755
autoupdate File 33.08 KB 0755
auvirt File 35.49 KB 0755
awk File 698.17 KB 0755
b2sum File 51.8 KB 0755
base32 File 35.7 KB 0755
base64 File 35.7 KB 0755
basename File 35.68 KB 0755
basenc File 48.02 KB 0755
bash File 1.32 MB 0755
bashbug File 6.91 KB 0755
bashbug-64 File 6.91 KB 0755
batch File 140 B 0755
bcomps File 23.37 KB 0755
bg File 30 B 0755
bison File 494.76 KB 0755
bond2team File 22.75 KB 0755
bootctl File 100.71 KB 0755
brotli File 753.47 KB 0755
bsqldb File 35.47 KB 0755
bsqlodbc File 31.37 KB 0755
bunzip2 File 40.1 KB 0755
busctl File 100.33 KB 0755
bwrap File 72.32 KB 0755
bzcat File 40.1 KB 0755
bzcmp File 2.09 KB 0755
bzdiff File 2.09 KB 0755
bzegrep File 2.01 KB 0755
bzfgrep File 2.01 KB 0755
bzgrep File 2.01 KB 0755
bzip2 File 40.1 KB 0755
bzip2recover File 15.89 KB 0755
bzless File 1.23 KB 0755
bzmore File 1.23 KB 0755
c++ File 1.04 MB 0755
c++filt File 27.38 KB 0755
c89 File 228 B 0755
c99 File 219 B 0755
ca-legacy File 1.61 KB 0755
cal File 52.02 KB 0755
canberra-boot File 19.07 KB 0755
canberra-gtk-play File 19.18 KB 0755
captoinfo File 87.8 KB 0755
cat File 35.66 KB 0755
catchsegv File 3.21 KB 0755
catman File 35.86 KB 0755
cc File 1.04 MB 0755
ccomps File 27.47 KB 0755
cd File 30 B 0755
centrino-decode File 14.13 KB 0755
chacl File 19.14 KB 0755
chage File 72.14 KB 4755
chattr File 15.19 KB 0755
chcat File 13.63 KB 0755
chcon File 60.24 KB 0755
checkmodule File 450.88 KB 0755
checkpolicy File 527.52 KB 0755
chfn File 31.48 KB 0711
chgrp File 56.17 KB 0755
chmem File 35.59 KB 0755
chmod File 56.19 KB 0755
choom File 23.48 KB 0755
chown File 60.2 KB 0755
chronyc File 100.83 KB 0755
chrt File 27.49 KB 0755
chsh File 23.41 KB 0711
chvt File 15.37 KB 0755
cifsiostat File 23.55 KB 0755
circo File 15.23 KB 0755
cksum File 35.58 KB 0755
cl-linksafe-apply-group File 558 B 0755
cl-linksafe-reconfigure File 4.83 KB 0755
clear File 15.15 KB 0755
clockdiff File 23.38 KB 0755
cluster File 47.7 KB 0755
cmp File 40.13 KB 0755
col File 23.43 KB 0755
colcrt File 15.39 KB 0755
colrm File 15.38 KB 0755
column File 35.53 KB 0755
comm File 35.77 KB 0755
command File 35 B 0755
compare File 15.27 KB 0755
compile_et File 1.31 KB 0755
composite File 15.27 KB 0755
config_data File 6.97 KB 0755
conjure File 15.27 KB 0755
convert File 15.27 KB 0755
coredumpctl File 60.03 KB 0755
corelist File 14.92 KB 0755
cp File 149.23 KB 0755
cpan File 8.06 KB 0755
cpan-mirrors File 4.19 KB 0755
cpansign File 1.98 KB 0755
cpapi1 File 3.15 MB 0755
cpapi2 File 3.15 MB 0755
cpapi3 File 3.15 MB 0755
cpio File 145.52 KB 0755
cpp File 1.04 MB 0755
cpupower File 79.92 KB 0755
crb File 2.29 KB 0744
crc32 File 1.02 KB 0755
cronnext File 39.93 KB 0755
crontab File 55.96 KB 4755
csplit File 108.88 KB 0755
curl File 248.67 KB 0755
curl-config File 4.93 KB 0755
cut File 47.82 KB 0755
cvtsudoers File 233.48 KB 0755
cxpm File 27.41 KB 0755
cyrusbdb2current File 1.58 MB 0755
datacopy File 31.43 KB 0755
date File 104.05 KB 0755
dbilogstrip File 1.35 KB 0755
dbiprof File 6.06 KB 0755
dbus-broker File 232 KB 0755
dbus-broker-launch File 130.02 KB 0755
dbus-monitor File 27.27 KB 0755
dbus-send File 27.22 KB 0755
dbus-update-activation-environment File 15.17 KB 0755
dbus-uuidgen File 15.14 KB 0755
dconf File 64.71 KB 0755
dd File 68.14 KB 0755
deallocvt File 15.38 KB 0755
debuginfo-install File 3.6 KB 0755
debuginfod-find File 19.44 KB 0755
defncopy File 31.43 KB 0755
delv File 45.58 KB 0755
df File 84.74 KB 0755
diff File 194.7 KB 0755
diff3 File 52.3 KB 0755
diffimg File 15.26 KB 0755
dig File 136.79 KB 0755
dijkstra File 19.44 KB 0755
dir File 137.66 KB 0755
dircolors File 39.81 KB 0755
dirmngr File 439.91 KB 0755
dirmngr-client File 56.12 KB 0755
dirname File 31.49 KB 0755
display File 15.27 KB 0755
distro File 953 B 0755
dltest File 15.68 KB 0755
dmesg File 71.98 KB 0755
dnf File 2.04 KB 0755
dnf-3 File 2.04 KB 0755
dnsdomainname File 23.84 KB 0755
dnstap-read File 23.39 KB 0755
domainname File 23.84 KB 0755
dot File 15.23 KB 0755
dot2gxl File 39.93 KB 0755
dotty File 2.04 KB 0755
doveadm File 826.66 KB 0755
doveconf File 220.09 KB 0755
dovecot-sysreport File 5.8 KB 0755
dpkg File 316.64 KB 0755
dpkg-deb File 149.83 KB 0755
dpkg-divert File 125.9 KB 0755
dpkg-maintscript-helper File 20.71 KB 0755
dpkg-query File 142.3 KB 0755
dpkg-realpath File 31.8 KB 0755
dpkg-split File 104.9 KB 0755
dpkg-statoverride File 52.16 KB 0755
dpkg-trigger File 44.23 KB 0755
dracut File 97.54 KB 0755
dsync File 826.66 KB 0755
dtrace File 17.38 KB 0755
du File 149.45 KB 0755
dumpkeys File 164.06 KB 0755
dwp File 851.8 KB 0755
dwz File 216.88 KB 0755
ea-php81 File 10.8 MB 0755
ea-php81-pear File 383 B 0755
ea-php81-pecl File 299 B 0755
ea-php82 File 10.88 MB 0755
ea-php82-pear File 383 B 0755
ea-php82-pecl File 299 B 0755
ea-php83 File 10.92 MB 0755
ea-php83-pear File 383 B 0755
ea-php83-pecl File 299 B 0755
echo File 35.48 KB 0755
ed File 52.51 KB 0755
edgepaint File 2.46 MB 0755
egrep File 32 B 0755
eject File 43.8 KB 0755
elfedit File 36.02 KB 0755
enc2xs File 40.69 KB 0755
encguess File 2.92 KB 0755
enchant-2 File 23.82 KB 0755
enchant-lsmod-2 File 15.82 KB 0755
env File 44.23 KB 0755
envml File 4.11 KB 0755
envsubst File 35.39 KB 0755
eps2eps File 643 B 0755
eqn File 189.52 KB 0755
event_rpcgen.py File 53.65 KB 0755
evmctl File 65.7 KB 0755
ex File 1.39 MB 0755
exempi File 28.18 KB 0755
exiv2 File 199.82 KB 0755
expand File 39.74 KB 0755
expr File 108.6 KB 0755
factor File 72.05 KB 0755
fallocate File 23.39 KB 0755
false File 27.48 KB 0755
fc File 30 B 0755
fc-cache File 139 B 0755
fc-cache-64 File 23.17 KB 0755
fc-cat File 19.16 KB 0755
fc-conflist File 15.13 KB 0755
fc-list File 15.13 KB 0755
fc-match File 15.13 KB 0755
fc-pattern File 15.14 KB 0755
fc-query File 15.13 KB 0755
fc-scan File 15.14 KB 0755
fc-validate File 15.14 KB 0755
fdp File 15.23 KB 0755
fg File 30 B 0755
fgconsole File 15.37 KB 0755
fgrep File 32 B 0755
filan File 47.84 KB 0755
file File 27.74 KB 0755
fincore File 23.49 KB 0755
find File 284.95 KB 0755
find-repos-of-install File 3.6 KB 0755
findmnt File 64.93 KB 0755
fips-finish-install File 1.72 KB 0755
fips-mode-setup File 8.02 KB 0755
firewall-cmd File 140.16 KB 0755
firewall-offline-cmd File 121.05 KB 0755
fisql File 35.47 KB 0755
flatpak File 1.75 MB 0755
flatpak-bisect File 7.66 KB 0755
flatpak-coredumpctl File 3.35 KB 0755
flex File 412.64 KB 0755
flex++ File 412.64 KB 0755
flock File 23.56 KB 0755
fmt File 39.77 KB 0755
fold File 39.72 KB 0755
free File 23.36 KB 0755
freebcp File 23.38 KB 0755
freetype-config File 4.32 KB 0755
fribidi File 28.59 KB 0755
ftp File 100.66 KB 0755
funzip File 31.44 KB 0755
fuse2fs File 72.69 KB 0755
fusermount File 35.54 KB 4755
g++ File 1.04 MB 0755
g13 File 110.29 KB 0755
galera_new_cluster File 921 B 0755
galera_recovery File 3.29 KB 0755
gapplication File 23.39 KB 0755
garb-systemd File 1.2 KB 0755
garbd File 2.39 MB 0755
gawk File 698.17 KB 0755
gc File 19.39 KB 0755
gcc File 1.04 MB 0755
gcc-ar File 27.82 KB 0755
gcc-nm File 27.8 KB 0755
gcc-ranlib File 27.82 KB 0755
gcov File 469.12 KB 0755
gcov-dump File 283.73 KB 0755
gcov-tool File 312.44 KB 0755
gdbm_dump File 28.22 KB 0755
gdbm_load File 36.48 KB 0755
gdbmtool File 149.26 KB 0755
gdbus File 51.68 KB 0755
gdbus-codegen File 1.99 KB 0755
gdk-pixbuf-query-loaders-64 File 15.34 KB 0755
gdk-pixbuf-thumbnailer File 19.32 KB 0755
gencat File 27.64 KB 0755
genl-ctrl-list File 15.3 KB 0755
geqn File 189.52 KB 0755
getconf File 35.41 KB 0755
getent File 36.03 KB 0755
getfacl File 31.8 KB 0755
getfattr File 24.35 KB 0755
getkeycodes File 15.36 KB 0755
getopt File 23.46 KB 0755
getopts File 35 B 0755
gettext File 35.35 KB 0755
gettext.sh File 5.07 KB 0755
gettextize File 41.25 KB 0755
ghostscript File 15.31 KB 0755
gio File 91.99 KB 0755
gio-querymodules-64 File 15.3 KB 0755
git File 22.87 MB 0755
git-receive-pack File 22.87 MB 0755
git-shell File 6.31 MB 0755
git-upload-archive File 22.87 MB 0755
git-upload-pack File 22.87 MB 0755
glib-compile-resources File 43.52 KB 0755
glib-compile-schemas File 51.65 KB 0755
glib-genmarshal File 40.14 KB 0755
glib-gettextize File 5.26 KB 0755
glib-mkenums File 30.08 KB 0755
gmake File 249.8 KB 0755
gml2gv File 47.78 KB 0755
gneqn File 916 B 0755
gnroff File 3.21 KB 0755
gobject-query File 15.35 KB 0755
gpasswd File 76.35 KB 4755
gpg File 1.07 MB 0755
gpg-agent File 342.25 KB 0755
gpg-card File 170.13 KB 0755
gpg-connect-agent File 84.75 KB 0755
gpg-error File 36.1 KB 0755
gpg-error-config File 1.98 KB 0755
gpg-wks-client File 129.55 KB 0755
gpg-wks-server File 113.33 KB 0755
gpg2 File 1.07 MB 0755
gpgconf File 100.99 KB 0755
gpgme-json File 84.63 KB 0755
gpgparsemail File 35.33 KB 0755
gpgrt-config File 13.13 KB 0755
gpgsplit File 27.49 KB 0755
gpgtar File 64.87 KB 0755
gpgv File 295.42 KB 0755
gpgv2 File 295.42 KB 0755
gpic File 201.72 KB 0755
gpio-event-mon File 18.13 KB 0755
gpio-hammer File 14.12 KB 0755
gpio-watch File 14.12 KB 0755
gprof File 101.66 KB 0755
gr2fonttest File 28 KB 0755
graphml2gv File 23.55 KB 0755
grep File 154.49 KB 0755
gresource File 23.46 KB 0755
groff File 96.77 KB 0755
grops File 167.26 KB 0755
grotty File 122.2 KB 0755
groups File 35.68 KB 0755
grub2-editenv File 463.6 KB 0755
grub2-file File 1.08 MB 0755
grub2-menulst2cfg File 269.65 KB 0755
grub2-mkimage File 438.44 KB 0755
grub2-mkpasswd-pbkdf2 File 294.98 KB 0755
grub2-mkrelpath File 282.31 KB 0755
grub2-mount File 1018.09 KB 0755
grub2-script-check File 315.09 KB 0755
gs File 15.31 KB 0755
gsbj File 354 B 0755
gsdj File 356 B 0755
gsdj500 File 356 B 0755
gsettings File 31.56 KB 0755
gsf-office-thumbnailer File 20.07 KB 0755
gslj File 357 B 0755
gslp File 354 B 0755
gsnd File 281 B 0755
gsoelim File 32.18 KB 0755
gst-inspect-1.0 File 71.59 KB 0755
gst-launch-1.0 File 39.3 KB 0755
gst-stats-1.0 File 35.45 KB 0755
gst-typefind-1.0 File 19.17 KB 0755
gtar File 514.27 KB 0755
gtbl File 130.86 KB 0755
gtester File 31.47 KB 0755
gtester-report File 18.64 KB 0755
gtk-launch File 19.48 KB 0755
gtk-query-immodules-2.0-64 File 19.17 KB 0755
gtk-query-immodules-3.0-64 File 23.47 KB 0755
gtk-update-icon-cache File 40.02 KB 0755
gtroff File 732.07 KB 0755
gunzip File 2.29 KB 0755
gv2gml File 23.41 KB 0755
gv2gxl File 39.93 KB 0755
gvcolor File 49.59 KB 0755
gvgen File 23.41 KB 0755
gvmap File 2.75 MB 0755
gvmap.sh File 2.14 KB 0755
gvpack File 398.14 KB 0755
gvpr File 15.2 KB 0755
gxl2dot File 39.93 KB 0755
gxl2gv File 39.93 KB 0755
gzexe File 6.3 KB 0755
gzip File 89.63 KB 0755
h2ph File 28.69 KB 0755
h2xs File 59.5 KB 0755
hardlink File 35.63 KB 0755
hash File 32 B 0755
hb-ot-shape-closure File 43.66 KB 0755
hb-shape File 47.91 KB 0755
hb-subset File 39.66 KB 0755
hb-view File 64.01 KB 0755
head File 43.8 KB 0755
hexdump File 51.6 KB 0755
host File 108.77 KB 0755
hostid File 31.67 KB 0755
hostname File 23.84 KB 0755
hostnamectl File 31.67 KB 0755
htdbm File 38.53 KB 0755
htdigest File 25.71 KB 0755
htpasswd File 38.66 KB 0755
httxt2dbm File 24.73 KB 0755
hunspell File 102.67 KB 0755
i386 File 27.67 KB 0755
iconv File 64.38 KB 0755
icu-config File 205 B 0755
icu-config-64 File 21.67 KB 0755
icuinfo File 16.07 KB 0755
id File 39.72 KB 0755
identify File 15.27 KB 0755
idiag-socket-details File 15.34 KB 0755
idn File 36.46 KB 0755
ifnames File 4.03 KB 0755
iio_event_monitor File 30.13 KB 0755
iio_generic_buffer File 34.14 KB 0755
ima-add-sigs File 2.49 KB 0755
ima-setup File 3.59 KB 0755
import File 15.27 KB 0755
imunify-antivirus File 1 KB 0755
imunify-service File 1020 B 0755
imunify360-agent File 1 KB 0755
imunify360-command-wrapper File 8.4 KB 0755
info File 312.73 KB 0755
infocmp File 63.68 KB 0755
infotocap File 87.8 KB 0755
innochecksum File 4.57 MB 0755
install File 149.29 KB 0755
instmodsh File 4.1 KB 0755
intel-speed-select File 112.66 KB 0755
ionice File 15.41 KB 0755
iostat File 55.86 KB 0755
ipcmk File 23.49 KB 0755
ipcrm File 19.42 KB 0755
ipcs File 39.54 KB 0755
iptc File 29.3 KB 0755
irqtop File 35.47 KB 0755
isosize File 15.34 KB 0755
ispell File 992 B 0755
isql File 40.01 KB 0755
iusql File 31.95 KB 0755
jobs File 32 B 0755
join File 51.88 KB 0755
journalctl File 88.27 KB 0755
jq File 31.38 KB 0755
json_pp File 4.78 KB 0755
json_reformat File 19.34 KB 0755
json_verify File 15.12 KB 0755
json_xs File 6.85 KB 0755
kbd_mode File 15.7 KB 0755
kbdinfo File 19.39 KB 0755
kbdrate File 19.4 KB 0755
kdumpctl File 47.16 KB 0755
kernel-install File 13.24 KB 0755
keyctl File 64.02 KB 0755
kill File 31.48 KB 0755
killall File 32.95 KB 0755
kmod File 165.76 KB 0755
krb5-config File 6.59 KB 0755
kvm_stat File 62.92 KB 0755
last File 35.49 KB 0755
lastb File 35.49 KB 0755
lastlog File 28.8 KB 0755
lchfn File 23.32 KB 0755
lchsh File 23.32 KB 0755
ld File 1.7 MB 0755
ld.bfd File 1.7 MB 0755
ld.gold File 2.03 MB 0755
ld.so File 871.77 KB 0755
ldd File 5.32 KB 0755
lefty File 300.45 KB 0755
less File 197.9 KB 0755
lessecho File 15.37 KB 0755
lesskey File 24.8 KB 0755
lesspipe.sh File 3.5 KB 0755
lex File 412.64 KB 0755
lexgrog File 88.19 KB 0755
libnetcfg File 15.41 KB 0755
libpng-config File 2.38 KB 0755
libpng16-config File 2.38 KB 0755
libtool File 359.18 KB 0755
libtoolize File 126.17 KB 0755
libwmf-fontmap File 13.03 KB 0755
link File 31.67 KB 0755
linux-boot-prober File 5.86 KB 0755
linux32 File 27.67 KB 0755
linux64 File 27.67 KB 0755
ln File 60.17 KB 0755
lneato File 1.51 KB 0755
loadkeys File 200.55 KB 0755
loadunimap File 31.63 KB 0755
locale File 59.34 KB 0755
localectl File 31.63 KB 0755
localedef File 314.54 KB 0755
logger File 36.17 KB 0755
login File 43.64 KB 0755
loginctl File 68.13 KB 0755
logname File 31.67 KB 0755
logresolve File 25.06 KB 0755
look File 19.37 KB 0755
ls File 137.65 KB 0755
lsattr File 15.18 KB 0755
lsblk File 124.58 KB 0755
lscpu File 108.44 KB 0755
lsgpio File 14.3 KB 0755
lsiio File 22.14 KB 0755
lsinitrd File 11.85 KB 0755
lsipc File 51.7 KB 0755
lsirq File 23.44 KB 0755
lslocks File 31.78 KB 0755
lslogins File 51.7 KB 0755
lsmem File 35.73 KB 0755
lsns File 39.52 KB 0755
lsof File 175.06 KB 0755
lsphp File 937 B 0755
lsscsi File 89.44 KB 0755
lto-dump File 26.58 MB 0755
lua File 23.23 KB 0755
luac File 157.69 KB 0755
lwp-download File 10.05 KB 0755
lwp-dump File 2.65 KB 0755
lwp-mirror File 2.36 KB 0755
lwp-request File 15.82 KB 0755
lwsCP File 271.55 KB 0755
m4 File 240.4 KB 0755
mail File 1014.48 KB 0755
mailx File 1014.48 KB 0755
mailx.s-nail File 1014.48 KB 0755
make File 249.8 KB 0755
make-dummy-cert File 614 B 0755
man File 114.91 KB 0755
man-recode File 28.01 KB 0755
man.man-db File 114.91 KB 0755
mandb File 133.01 KB 0755
manpath File 31.82 KB 0755
mapscrn File 31.58 KB 0755
mariadb File 5.07 MB 0755
mariadb-access File 109.34 KB 0755
mariadb-admin File 4.85 MB 0755
mariadb-binlog File 5.13 MB 0755
mariadb-check File 4.84 MB 0755
mariadb-config File 15.79 KB 0755
mariadb-conv File 4.56 MB 0755
mariadb-convert-table-format File 4.12 KB 0755
mariadb-dump File 4.93 MB 0755
mariadb-dumpslow File 8.05 KB 0755
mariadb-embedded File 24.19 MB 0755
mariadb-find-rows File 3.21 KB 0755
mariadb-fix-extensions File 1.22 KB 0755
mariadb-hotcopy File 34.52 KB 0755
mariadb-import File 4.84 MB 0755
mariadb-install-db File 22.11 KB 0755
mariadb-plugin File 4.53 MB 0755
mariadb-secure-installation File 13.49 KB 0755
mariadb-service-convert File 2.45 KB 0755
mariadb-setpermission File 17.56 KB 0755
mariadb-show File 4.83 MB 0755
mariadb-slap File 4.85 MB 0755
mariadb-tzinfo-to-sql File 4.53 MB 0755
mariadb-upgrade File 4.97 MB 0755
mariadb-waitpid File 4.52 MB 0755
mariadb_config File 15.79 KB 0755
mariadbd-multi File 26.71 KB 0755
mariadbd-safe File 30.43 KB 0755
mariadbd-safe-helper File 4.5 MB 0755
mcookie File 27.51 KB 0755
md5sum File 39.65 KB 0755
mdb_copy File 15.7 KB 0755
mdb_dump File 15.84 KB 0755
mdb_load File 23.84 KB 0755
mdb_stat File 15.8 KB 0755
mdig File 51.5 KB 0755
mesg File 15.34 KB 0755
mkdir File 68.31 KB 0755
mkfifo File 39.83 KB 0755
mkfontdir File 69 B 0755
mkfontscale File 44.77 KB 0755
mknod File 43.88 KB 0755
mktemp File 39.81 KB 0755
mm2gv File 39.45 KB 0755
mmdblookup File 27.72 KB 0755
modulecmd File 654.01 KB 0755
modulemd-validator File 28.39 KB 0755
mogrify File 15.27 KB 0755
montage File 15.27 KB 0755
more File 43.63 KB 0755
mount File 47.54 KB 0755
mountpoint File 19.38 KB 0755
mpstat File 51.79 KB 0755
msgattrib File 27.17 KB 0755
msgcat File 27.14 KB 0755
msgcmp File 27.27 KB 0755
msgcomm File 27.16 KB 0755
msgconv File 23.15 KB 0755
msgen File 23.15 KB 0755
msgexec File 23.15 KB 0755
msgfilter File 35.31 KB 0755
msgfmt File 84.09 KB 0755
msgfmt.py File 7.41 KB 0755
msgfmt3.9.py File 7.41 KB 0755
msgfmt3.py File 7.41 KB 0755
msggrep File 116.41 KB 0755
msginit File 67.44 KB 0755
msgmerge File 75.48 KB 0755
msgunfmt File 35.33 KB 0755
msguniq File 23.15 KB 0755
msql2mysql File 1.42 KB 0755
mv File 141.17 KB 0755
my_print_defaults File 4.53 MB 0755
myisam_ftdump File 4.86 MB 0755
myisamchk File 4.98 MB 0755
myisamlog File 4.84 MB 0755
myisampack File 4.89 MB 0755
mysql File 5.07 MB 0755
mysql_config File 4.57 KB 0755
mysql_embedded File 24.19 MB 0755
mysql_find_rows File 3.21 KB 0755
mysql_fix_extensions File 1.22 KB 0755
mysql_install_db File 22.11 KB 0755
mysql_plugin File 4.53 MB 0755
mysql_tzinfo_to_sql File 4.53 MB 0755
mysql_upgrade File 4.97 MB 0755
mysql_waitpid File 4.52 MB 0755
mysqlaccess File 109.34 KB 0755
mysqladmin File 4.85 MB 0755
mysqlbinlog File 5.13 MB 0755
mysqlcheck File 4.84 MB 0755
mysqld_multi File 26.71 KB 0755
mysqld_safe File 30.43 KB 0755
mysqld_safe_helper File 4.5 MB 0755
mysqldump File 4.93 MB 0755
mysqlimport File 4.84 MB 0755
mysqlshow File 4.83 MB 0755
mysqlslap File 4.85 MB 0755
mytop File 71.95 KB 0755
nail File 1014.48 KB 0755
named-rrchecker File 23.34 KB 0755
namei File 23.42 KB 0755
nano File 346.22 KB 0755
nc File 52.02 KB 0755
ncurses6-config File 8.13 KB 0755
ncursesw6-config File 8.13 KB 0755
ndptool File 27.42 KB 0755
neato File 15.23 KB 0755
needs-restarting File 3.6 KB 0755
neqn File 916 B 0755
netcat File 52.02 KB 0755
netstat File 156.85 KB 0755
newgidmap File 42.13 KB 0755
newgrp File 40.94 KB 4755
newuidmap File 38.1 KB 0755
nf-ct-add File 15.72 KB 0755
nf-ct-events File 15.16 KB 0755
nf-ct-list File 15.74 KB 0755
nf-exp-add File 20.13 KB 0755
nf-exp-delete File 15.91 KB 0755
nf-exp-list File 15.75 KB 0755
nf-log File 15.14 KB 0755
nf-monitor File 15.15 KB 0755
nf-queue File 15.14 KB 0755
ngettext File 35.34 KB 0755
nice File 35.68 KB 0755
nisdomainname File 23.84 KB 0755
nl File 100.7 KB 0755
nl-addr-add File 15.59 KB 0755
nl-addr-delete File 15.64 KB 0755
nl-addr-list File 19.66 KB 0755
nl-class-add File 15.58 KB 0755
nl-class-delete File 15.48 KB 0755
nl-class-list File 15.46 KB 0755
nl-classid-lookup File 15.33 KB 0755
nl-cls-add File 19.63 KB 0755
nl-cls-delete File 15.55 KB 0755
nl-cls-list File 15.51 KB 0755
nl-fib-lookup File 15.35 KB 0755
nl-link-enslave File 15.11 KB 0755
nl-link-ifindex2name File 15.11 KB 0755
nl-link-list File 15.5 KB 0755
nl-link-name2ifindex File 15.11 KB 0755
nl-link-release File 15.12 KB 0755
nl-link-set File 15.56 KB 0755
nl-link-stats File 15.36 KB 0755
nl-list-caches File 15.12 KB 0755
nl-list-sockets File 15.11 KB 0755
nl-monitor File 15.3 KB 0755
nl-neigh-add File 15.48 KB 0755
nl-neigh-delete File 15.52 KB 0755
nl-neigh-list File 15.44 KB 0755
nl-neightbl-list File 15.27 KB 0755
nl-nh-list File 15.3 KB 0755
nl-pktloc-lookup File 15.36 KB 0755
nl-qdisc-add File 15.52 KB 0755
nl-qdisc-delete File 15.48 KB 0755
nl-qdisc-list File 19.51 KB 0755
nl-route-add File 19.66 KB 0755
nl-route-delete File 19.74 KB 0755
nl-route-get File 15.14 KB 0755
nl-route-list File 15.69 KB 0755
nl-rule-list File 15.3 KB 0755
nl-tctree-list File 15.42 KB 0755
nl-util-addr File 15.11 KB 0755
nm File 44.91 KB 0755
nm-online File 23.55 KB 0755
nmcli File 1.01 MB 0755
nmtui File 821.41 KB 0755
nmtui-connect File 821.41 KB 0755
nmtui-edit File 821.41 KB 0755
nmtui-hostname File 821.41 KB 0755
nohup File 35.59 KB 0755
nop File 15.33 KB 0755
notify-send File 19.75 KB 0755
nproc File 35.7 KB 0755
nroff File 3.21 KB 0755
nsenter File 27.66 KB 0755
nslookup File 112.73 KB 0755
nsupdate File 71.99 KB 0755
numfmt File 55.83 KB 0755
objcopy File 185.56 KB 0755
objdump File 413.3 KB 0755
od File 64.07 KB 0755
odbc_config File 15.7 KB 0755
odbcinst File 23.9 KB 0755
openssl File 1.01 MB 0755
openvt File 23.75 KB 0755
orc-bugreport File 23.31 KB 0755
os-prober File 5.78 KB 0755
osage File 15.23 KB 0755
osinfo-db-export File 27.35 KB 0755
osinfo-db-import File 27.3 KB 0755
osinfo-db-path File 15.3 KB 0755
osinfo-db-validate File 23.4 KB 0755
osinfo-detect File 27.4 KB 0755
osinfo-install-script File 31.77 KB 0755
osinfo-query File 32.19 KB 0755
osql File 9.48 KB 0755
p11-kit File 188.31 KB 0755
package-cleanup File 3.6 KB 0755
page_owner_sort File 26.13 KB 0755
pango-list File 19.11 KB 0755
pango-segmentation File 19.13 KB 0755
pango-view File 60.17 KB 0755
paperconf File 15.8 KB 0755
passwd File 31.89 KB 4755
paste File 35.59 KB 0755
patch File 195.02 KB 0755
patchwork File 15.23 KB 0755
pathchk File 35.66 KB 0755
pathfix.py File 6.63 KB 0755
pathfix3.9.py File 6.63 KB 0755
pcre-config File 2.09 KB 0755
pcre2-config File 1.91 KB 0755
pdf2dsc File 701 B 0755
pdf2ps File 913 B 0755
pdns_control File 484.45 KB 0755
pdnsutil File 4.84 MB 0755
peekfd File 15.8 KB 0755
perl File 15.25 KB 0755
perl5.32.1 File 15.25 KB 0755
perlbug File 43.81 KB 0755
perldoc File 118 B 0755
perlivp File 10.56 KB 0755
perlml File 14.18 KB 0755
perlthanks File 43.81 KB 0755
perror File 4.72 MB 0755
pf2afm File 502 B 0755
pfbtopfa File 520 B 0755
pftp File 100.66 KB 0755
pgrep File 31.42 KB 0755
php File 937 B 0755
pic File 201.72 KB 0755
piconv File 8.08 KB 0755
pidof File 23.33 KB 0755
pidstat File 51.8 KB 0755
pidwait File 31.42 KB 0755
pigz File 129.81 KB 0755
ping File 76.66 KB 0755
pinky File 35.62 KB 0755
pip File 648 B 0755
pip-3 File 648 B 0755
pip-3.9 File 648 B 0755
pip3 File 648 B 0755
pip3.9 File 648 B 0755
pipewire File 15.14 KB 0755
pipewire-aes67 File 15.14 KB 0755
pipewire-avb File 15.14 KB 0755
pipewire-pulse File 15.14 KB 0755
pipewire-vulkan File 15.14 KB 0755
pkaction File 19.37 KB 0755
pkcheck File 23.37 KB 0755
pkexec File 31.38 KB 4755
pkg-config File 335 B 0755
pkgconf File 45.36 KB 0755
pkill File 31.42 KB 0755
pkla-admin-identities File 23.96 KB 0755
pkla-check-authorization File 36.1 KB 0755
pkttyagent File 23.36 KB 0755
pl2pm File 4.43 KB 0755
pldd File 23.57 KB 0755
plesk_configure File 346 B 0755
pmap File 35.39 KB 0755
png-fix-itxt File 15.69 KB 0755
pngfix File 60.23 KB 0755
pod2html File 4.04 KB 0755
pod2man File 14.68 KB 0755
pod2text File 10.55 KB 0755
pod2usage File 4.01 KB 0755
podchecker File 3.57 KB 0755
post-grohtml File 199.76 KB 0755
powernow-k8-decode File 14.13 KB 0755
pphs File 408 B 0755
pr File 72.3 KB 0755
pre-grohtml File 92.92 KB 0755
precat File 5.53 KB 0755
preconv File 56.27 KB 0755
preunzip File 5.53 KB 0755
prezip File 5.53 KB 0755
prezip-bin File 15.69 KB 0755
printafm File 399 B 0755
printenv File 31.48 KB 0755
printf File 51.78 KB 0755
prlimit File 27.95 KB 0755
procan File 35.62 KB 0755
protoc File 24.01 KB 0755
protoc-c File 158.2 KB 0755
protoc-gen-c File 158.2 KB 0755
prove File 13.24 KB 0755
prtstat File 23.84 KB 0755
prune File 15.41 KB 0755
ps File 141.15 KB 0755
ps2ascii File 635 B 0755
ps2epsi File 1.24 KB 0755
ps2pdf File 276 B 0755
ps2pdf12 File 219 B 0755
ps2pdf13 File 219 B 0755
ps2pdf14 File 219 B 0755
ps2pdfwr File 1.06 KB 0755
ps2ps File 651 B 0755
ps2ps2 File 673 B 0755
psfaddtable File 31.45 KB 0755
psfgettable File 31.45 KB 0755
psfstriptable File 31.45 KB 0755
psfxtable File 31.45 KB 0755
pslog File 15.7 KB 0755
pstree File 36.9 KB 0755
pstree.x11 File 36.9 KB 0755
ptar File 3.39 KB 0755
ptardiff File 2.49 KB 0755
ptargrep File 4.2 KB 0755
ptx File 129.04 KB 0755
pv File 65.35 KB 0755
pw-jack File 1.32 KB 0755
pwd File 35.7 KB 0755
pwdx File 15.28 KB 0755
pwmake File 15.7 KB 0755
pwscore File 15.7 KB 0755
pydoc File 78 B 0755
pydoc3 File 78 B 0755
pydoc3.9 File 78 B 0755
pygettext.py File 21.03 KB 0755
pygettext3.9.py File 21.03 KB 0755
pygettext3.py File 21.03 KB 0755
python File 15.27 KB 0755
python-config File 61 B 0755
python3 File 15.27 KB 0755
python3-config File 61 B 0755
python3.9 File 15.27 KB 0755
python3.9-config File 61 B 0755
python3.9-x86_64-config File 3.54 KB 0755
qemu-ga File 1.81 MB 0755
quota File 81.7 KB 4755
quotasync File 64.88 KB 0755
ranlib File 56.2 KB 0755
re2c File 654.16 KB 0755
re2go File 654.16 KB 0755
read File 32 B 0755
readelf File 667.48 KB 0755
readlink File 39.7 KB 0755
realpath File 39.77 KB 0755
recode-sr-latin File 15.13 KB 0755
red File 92 B 0755
rename File 23.42 KB 0755
renew-dummy-cert File 729 B 0755
renice File 15.37 KB 0755
replace File 4.5 MB 0755
repo-graph File 3.6 KB 0755
repoclosure File 3.6 KB 0755
repodiff File 3.6 KB 0755
repomanage File 3.6 KB 0755
repoquery File 3.6 KB 0755
reposync File 3.6 KB 0755
repotrack File 3.6 KB 0755
rescan-scsi-bus.sh File 38.09 KB 0755
reset File 27.34 KB 0755
resizecons File 27.57 KB 0755
resolve_stack_dump File 4.53 MB 0755
resolveip File 4.52 MB 0755
rev File 15.36 KB 0755
rm File 60.21 KB 0755
rmdir File 43.62 KB 0755
rnano File 346.22 KB 0755
rpcbind File 59.89 KB 0755
rpcinfo File 35.58 KB 0755
rpm File 23.81 KB 0755
rpm2archive File 23.5 KB 0755
rpm2cpio File 15.29 KB 0755
rpmdb File 19.91 KB 0755
rpmkeys File 15.77 KB 0755
rpmquery File 23.81 KB 0755
rpmverify File 23.81 KB 0755
rsync File 554.87 KB 0755
rsync-ssl File 4.82 KB 0755
run-parts File 1.94 KB 0755
run-with-aspell File 89 B 0755
runcon File 35.65 KB 0755
rvi File 1.39 MB 0755
rview File 1.39 MB 0755
s-nail File 1014.48 KB 0755
sadf File 459.02 KB 0755
sar File 135.88 KB 0755
sccmap File 23.37 KB 0755
scl File 39.55 KB 0755
scl_enabled File 262 B 0755
scl_source File 1.88 KB 0755
scp File 133.07 KB 0755
script File 51.76 KB 0755
scriptlive File 43.67 KB 0755
scriptreplay File 35.49 KB 0755
scsi-rescan File 38.09 KB 0755
scsi_logging_level File 8.39 KB 0755
scsi_mandat File 3.52 KB 0755
scsi_readcap File 1.3 KB 0755
scsi_ready File 1.1 KB 0755
scsi_satl File 3.74 KB 0755
scsi_start File 1.26 KB 0755
scsi_stop File 1.44 KB 0755
scsi_temperature File 940 B 0755
sdiff File 44.2 KB 0755
secon File 28.37 KB 0755
sed File 114.01 KB 0755
sedismod File 289.02 KB 0755
sedispol File 219.93 KB 0755
semodule_expand File 15.23 KB 0755
semodule_link File 15.25 KB 0755
semodule_package File 19.28 KB 0755
semodule_unpackage File 15.24 KB 0755
seq File 47.8 KB 0755
sestatus File 23.25 KB 0755
setarch File 27.67 KB 0755
setfacl File 39.98 KB 0755
setfattr File 20.16 KB 0755
setfont File 51.82 KB 0755
setkeycodes File 15.41 KB 0755
setleds File 19.46 KB 0755
setmetamode File 15.49 KB 0755
setpriv File 39.55 KB 0755
setsid File 15.35 KB 0755
setterm File 35.52 KB 0755
setup-nsssysinit File 1.51 KB 0755
setup-nsssysinit.sh File 1.51 KB 0755
setvtrgb File 15.45 KB 0755
sfdp File 15.23 KB 0755
sftp File 141.05 KB 0755
sg File 40.94 KB 4755
sg_bg_ctl File 15.93 KB 0755
sg_compare_and_write File 28.35 KB 0755
sg_copy_results File 24.65 KB 0755
sg_dd File 56.04 KB 0755
sg_decode_sense File 16.23 KB 0755
sg_emc_trespass File 15.71 KB 0755
sg_format File 40.9 KB 0755
sg_get_config File 36.75 KB 0755
sg_get_elem_status File 28.22 KB 0755
sg_get_lba_status File 24.38 KB 0755
sg_ident File 16.01 KB 0755
sg_inq File 121.35 KB 0755
sg_logs File 154.06 KB 0755
sg_luns File 24.31 KB 0755
sg_map File 19.84 KB 0755
sg_map26 File 28.31 KB 0755
sg_modes File 47.65 KB 0755
sg_opcodes File 36.61 KB 0755
sg_persist File 37.59 KB 0755
sg_prevent File 15.91 KB 0755
sg_raw File 28.34 KB 0755
sg_rbuf File 24.26 KB 0755
sg_rdac File 15.69 KB 0755
sg_read File 27.84 KB 0755
sg_read_attr File 38.18 KB 0755
sg_read_block_limits File 15.95 KB 0755
sg_read_buffer File 28.93 KB 0755
sg_read_long File 16.12 KB 0755
sg_readcap File 24.31 KB 0755
sg_reassign File 16.07 KB 0755
sg_referrals File 16.09 KB 0755
sg_rep_pip File 15.99 KB 0755
sg_rep_zones File 28.41 KB 0755
sg_requests File 24.17 KB 0755
sg_reset File 16.18 KB 0755
sg_reset_wp File 16.02 KB 0755
sg_rmsn File 15.91 KB 0755
sg_rtpg File 16.01 KB 0755
sg_safte File 24.13 KB 0755
sg_sanitize File 28.43 KB 0755
sg_sat_identify File 20.16 KB 0755
sg_sat_phy_event File 20.44 KB 0755
sg_sat_read_gplog File 20.15 KB 0755
sg_sat_set_features File 20.11 KB 0755
sg_scan File 19.84 KB 0755
sg_seek File 20.3 KB 0755
sg_senddiag File 28.74 KB 0755
sg_ses File 121.71 KB 0755
sg_ses_microcode File 28.91 KB 0755
sg_start File 20.38 KB 0755
sg_stpg File 24.13 KB 0755
sg_stream_ctl File 20.13 KB 0755
sg_sync File 16.08 KB 0755
sg_test_rwbuf File 20.17 KB 0755
sg_timestamp File 24.29 KB 0755
sg_turs File 28.27 KB 0755
sg_unmap File 24.28 KB 0755
sg_verify File 20.33 KB 0755
sg_vpd File 120.15 KB 0755
sg_wr_mode File 24.13 KB 0755
sg_write_buffer File 28.67 KB 0755
sg_write_long File 16.18 KB 0755
sg_write_same File 28.4 KB 0755
sg_write_verify File 28.23 KB 0755
sg_write_x File 61.23 KB 0755
sg_xcopy File 44.02 KB 0755
sg_zone File 20.21 KB 0755
sginfo File 74.25 KB 0755
sgm_dd File 40 KB 0755
sgp_dd File 44.45 KB 0755
sh File 1.32 MB 0755
sha1hmac File 35.27 KB 0755
sha1sum File 39.65 KB 0755
sha224hmac File 35.27 KB 0755
sha224sum File 39.65 KB 0755
sha256hmac File 35.27 KB 0755
sha256sum File 39.65 KB 0755
sha384hmac File 35.27 KB 0755
sha384sum File 39.65 KB 0755
sha512hmac File 35.27 KB 0755
sha512sum File 39.65 KB 0755
shasum File 9.66 KB 0755
showconsolefont File 19.48 KB 0755
showkey File 19.41 KB 0755
shred File 51.88 KB 0755
shuf File 48.02 KB 0755
size File 31.8 KB 0755
skill File 31.4 KB 0755
slabinfo File 42.95 KB 0755
slabtop File 23.42 KB 0755
sleep File 35.66 KB 0755
slencheck File 15.71 KB 0755
sm3hmac File 35.27 KB 0755
snice File 31.4 KB 0755
socat File 387.1 KB 0755
soelim File 32.18 KB 0755
soelim.groff File 32.18 KB 0755
sort File 113.11 KB 0755
sotruss File 4.18 KB 0755
spell File 125 B 0755
splain File 18.96 KB 0755
split File 52.33 KB 0755
sprof File 35.62 KB 0755
sqlite3 File 1.52 MB 0755
ssh File 843.51 KB 0755
ssh-add File 164.85 KB 0755
ssh-agent File 281.02 KB 0755
ssh-copy-id File 12.38 KB 0755
ssh-keygen File 455.02 KB 0755
ssh-keyscan File 197.44 KB 0755
sss_ssh_authorizedkeys File 23.47 KB 0755
sss_ssh_knownhostsproxy File 27.48 KB 0755
stat File 80.07 KB 0755
stdbuf File 43.75 KB 0755
strace File 1.94 MB 0755
strace-log-merge File 1.78 KB 0755
stream File 15.27 KB 0755
streamzip File 7.66 KB 0755
strings File 31.92 KB 0755
strip File 185.55 KB 0755
stty File 75.84 KB 0755
su File 55.79 KB 4750
sudo File 180.96 KB 4111
sudoedit File 180.96 KB 4111
sudoreplay File 84.97 KB 0111
sum File 35.6 KB 0755
sw-engine File 24.39 MB 0755
sxpm File 31.58 KB 0755
sync File 35.55 KB 0755
systemctl File 298.59 KB 0755
systemd-analyze File 201.77 KB 0755
systemd-ask-password File 19.63 KB 0755
systemd-cat File 19.44 KB 0755
systemd-cgls File 23.64 KB 0755
systemd-cgtop File 39.59 KB 0755
systemd-creds File 43.98 KB 0755
systemd-cryptenroll File 72.25 KB 0755
systemd-delta File 27.49 KB 0755
systemd-detect-virt File 19.44 KB 0755
systemd-dissect File 47.96 KB 0755
systemd-escape File 23.44 KB 0755
systemd-firstboot File 56.26 KB 0755
systemd-hwdb File 15.45 KB 0755
systemd-id128 File 27.55 KB 0755
systemd-inhibit File 23.48 KB 0755
systemd-machine-id-setup File 19.73 KB 0755
systemd-mount File 60.2 KB 0755
systemd-notify File 23.48 KB 0755
systemd-path File 19.42 KB 0755
systemd-repart File 169.41 KB 0755
systemd-run File 64.19 KB 0755
systemd-socket-activate File 27.52 KB 0755
systemd-stdio-bridge File 23.44 KB 0755
systemd-sysext File 47.94 KB 0755
systemd-sysusers File 72.53 KB 0755
systemd-tmpfiles File 124.71 KB 0755
systemd-tty-ask-password-agent File 39.55 KB 0755
systemd-umount File 60.2 KB 0755
tabs File 19.16 KB 0755
tac File 104.61 KB 0755
tail File 68.1 KB 0755
tapestat File 27.55 KB 0755
tar File 514.27 KB 0755
taskset File 23.41 KB 0755
tbl File 130.86 KB 0755
tcamgr File 27.88 KB 0755
tcamttest File 27.88 KB 0755
tcatest File 64.32 KB 0755
tcbmgr File 31.84 KB 0755
tcbmttest File 55.92 KB 0755
tcbtest File 72.3 KB 0755
tcfmgr File 27.82 KB 0755
tcfmttest File 39.92 KB 0755
tcftest File 51.91 KB 0755
tchmgr File 27.81 KB 0755
tchmttest File 51.93 KB 0755
tchtest File 64.27 KB 0755
tclsh File 15.69 KB 0755
tclsh8.6 File 15.69 KB 0755
tcptraceroute File 1.55 KB 0755
tctmgr File 35.83 KB 0755
tctmttest File 51.89 KB 0755
tcttest File 63.92 KB 0755
tcucodec File 35.8 KB 0755
tcumttest File 27.87 KB 0755
tcutest File 79.95 KB 0755
tdspool File 253.95 KB 0755
team2bond File 15.76 KB 0755
teamd File 166.59 KB 0755
teamdctl File 37.12 KB 0755
teamnl File 23.26 KB 0755
tee File 35.7 KB 0755
test File 43.8 KB 0755
tic File 87.8 KB 0755
timedatectl File 47.83 KB 0755
timeout File 40.18 KB 0755
tload File 19.34 KB 0755
tmon File 42.48 KB 0755
tmpwatch File 36.03 KB 0755
toe File 23.23 KB 0755
top File 132.27 KB 0755
touch File 92.04 KB 0755
tput File 27.25 KB 0755
tr File 47.87 KB 0755
tracepath File 19.39 KB 0755
traceroute File 77.26 KB 0755
traceroute6 File 77.26 KB 0755
tracker3 File 611.08 KB 0755
tred File 15.35 KB 0755
troff File 732.07 KB 0755
true File 27.48 KB 0755
truncate File 35.66 KB 0755
trust File 221.06 KB 0755
tset File 27.34 KB 0755
tsort File 47.8 KB 0755
tsql File 253.9 KB 0755
tty File 31.66 KB 0755
turbostat File 148.05 KB 0755
twopi File 15.23 KB 0755
type File 32 B 0755
tzselect File 14.99 KB 0755
uapi File 3.15 MB 0755
udevadm File 583.98 KB 0755
ul File 23.45 KB 0755
ulimit File 34 B 0755
ulockmgr_server File 19.4 KB 0755
umask File 33 B 0755
umount File 35.46 KB 0755
unalias File 35 B 0755
uname File 31.66 KB 0755
uname26 File 27.67 KB 0755
unexpand File 39.73 KB 0755
unflatten File 15.37 KB 0755
unicode_start File 2.57 KB 0755
unicode_stop File 367 B 0755
uniq File 43.84 KB 0755
unlink File 31.66 KB 0755
unpigz File 129.81 KB 0755
unshare File 31.75 KB 0755
unxz File 84.94 KB 0755
unzip File 196.15 KB 0755
unzipsfx File 87.91 KB 0755
update-ca-trust File 4.36 KB 0755
update-crypto-policies File 87 B 0755
update-gtk-immodules File 316 B 0755
update-mime-database File 59.87 KB 0755
upower File 23.88 KB 0755
uptime File 15.29 KB 0755
users File 35.69 KB 0755
usleep File 15.31 KB 0755
utmpdump File 23.4 KB 0755
uuidgen File 19.36 KB 0755
uuidparse File 23.41 KB 0755
vdir File 137.66 KB 0755
vi File 691 B 0755
view File 150 B 0755
vimdot File 1.06 KB 0755
vlock File 23.61 KB 0755
vmstat File 39.41 KB 0755
w File 23.37 KB 0755
wait File 32 B 0755
wall File 23.41 KB 0755
watch File 27.87 KB 0755
watchgnupg File 23.2 KB 0755
wc File 43.74 KB 0755
wdctl File 31.52 KB 0755
wget File 521.41 KB 0755
whatis File 48.52 KB 0755
whatis.man-db File 48.52 KB 0755
whereis File 32.04 KB 0755
which File 27.89 KB 0755
whiptail File 31.93 KB 0755
who File 51.77 KB 0755
whoami File 31.66 KB 0755
wireplumber File 31.67 KB 0755
wmf2eps File 19.72 KB 0755
wmf2fig File 19.81 KB 0755
wmf2gd File 15.81 KB 0755
wmf2svg File 19.82 KB 0755
wmf2x File 15.7 KB 0755
word-list-compress File 15.7 KB 0755
wpctl File 59.85 KB 0755
wpexec File 23.7 KB 0755
write File 23.42 KB 0755
wsrep_sst_backup File 2.39 KB 0755
wsrep_sst_common File 65.72 KB 0644
wsrep_sst_mariabackup File 48.1 KB 0755
wsrep_sst_mysqldump File 8.03 KB 0755
wsrep_sst_rsync File 29.69 KB 0755
wsrep_sst_rsync_wan File 29.69 KB 0755
x86_64 File 27.67 KB 0755
x86_64-redhat-linux-c++ File 1.04 MB 0755
x86_64-redhat-linux-g++ File 1.04 MB 0755
x86_64-redhat-linux-gcc File 1.04 MB 0755
x86_64-redhat-linux-gcc-11 File 1.04 MB 0755
x86_64-redhat-linux-gnu-pkg-config File 829 B 0755
x86_energy_perf_policy File 38.73 KB 0755
xargs File 64.09 KB 0755
xdg-dbus-proxy File 56.54 KB 0755
xgettext File 296.7 KB 0755
xml2-config File 1.83 KB 0755
xmlcatalog File 23.27 KB 0755
xmllint File 80.69 KB 0755
xmlwf File 39.81 KB 0755
xslt-config File 2.58 KB 0755
xsltproc File 31.88 KB 0755
xsubpp File 4.96 KB 0755
xz File 84.94 KB 0755
xzcat File 84.94 KB 0755
xzcmp File 6.48 KB 0755
xzdec File 15.85 KB 0755
xzdiff File 6.48 KB 0755
xzegrep File 5.77 KB 0755
xzfgrep File 5.77 KB 0755
xzgrep File 5.77 KB 0755
xzless File 1.76 KB 0755
xzmore File 2.12 KB 0755
yat2m File 40.04 KB 0755
yes File 31.52 KB 0755
ypdomainname File 23.84 KB 0755
yum File 2.04 KB 0755
yum-builddep File 3.6 KB 0755
yum-config-manager File 3.6 KB 0755
yum-debug-dump File 3.6 KB 0755
yum-debug-restore File 3.6 KB 0755
yum-groups-manager File 3.6 KB 0755
yumdownloader File 3.6 KB 0755
zcat File 1.94 KB 0755
zcmp File 1.64 KB 0755
zdiff File 6.31 KB 0755
zdump File 27.51 KB 0755
zegrep File 33 B 0755
zfgrep File 33 B 0755
zforce File 2.04 KB 0755
zgrep File 7.93 KB 0755
zip File 221.09 KB 0755
zipcloak File 75.7 KB 0755
zipdetails File 58.56 KB 0755
zipgrep File 2.89 KB 0755
zipinfo File 196.15 KB 0755
zipnote File 67.61 KB 0755
zipsplit File 63.58 KB 0755
zless File 2.16 KB 0755
zmore File 1.8 KB 0755
znew File 4.47 KB 0755
zone2json File 1.35 MB 0755
zone2sql File 1.37 MB 0755
zsoelim File 32.18 KB 0755